************************************************************************
*                                                                      *
      SUBROUTINE ALLOC (PTR,NMLOCS,LENGTH)
*                                                                      *
*   This  routine allocates  NMLOCS memory locations, each of length   *
*   LENGTH bytes to the pointee of the pointer PTR.  This version is   *
*   specific to CFT77 (UNICOS), IBM XL FORTRAN (AIX), or Sun FORTRAN   *
*   77 (Sun OS) depending upon the  action of the GRASP preprocessor   *
*   PREPRO.  LENGTH  is not required for the  CFT77  version --- the   *
*   8-byte  word length  is assumed common to all data types; it has   *
*   been retained to ensure compatibility  with the code that  calls   *
*   this subprogram.                                                   *
*                                                                      *
*   Original code by Charlotte F. Fischer.                             *
*                                                                      *
*   This version by Farid A. Parpia.      Last revision: 16 Oct 1994   *
*                                                                      *
************************************************************************
*
      INTEGER PTR
*
*   Compute the size of the memory region in bytes; this is retained for
*   calling compatibility and debugging purposes in the Cray version
*
      NBYTES = NMLOCS*LENGTH
*
      IF (NBYTES. LE. 0) THEN
*
*   Trap an invalid memory request
*
         PRINT *, 'ALLOC: Invalid memory request:'
         PRINT *, ' PTR = ',PTR,', NMLOCS = ',NMLOCS,
     :               ', LENGTH = ',LENGTH,'.'
         STOP
*
      ELSE
*
*   Attempt to allocate the memory region required and to get the
*   address (PTR) of the first byte of the region using routine
*
*
114      PTR = MALLOC (%VAL (NBYTES))
*
         IF (PTR .EQ. 0) THEN
*
*   Trap an unsuccessful allocation attempt
*
            PRINT *, 'ALLOC: Unable to allocate memory:'
            PRINT *, ' PTR = ',PTR,', NMLOCS =',NMLOCS,
     :                  ', LENGTH = ',LENGTH,
     :                  '.'
            STOP
*
         ENDIF
*
      ENDIF
*
      RETURN
      END
