/******************************************************************************/
/* V 1.0 - 02.09.97 - BAH
 * V 1.1 - 29.04.98 - BAH - result of malloc cast to (char *)
 * program to determine the package name of the current package,
 * defined as the last subpath in the present working directory
 * containing a hyphen
 * pkgname -s                  print short name (name before the hyphen)
 * pkgname -l                  print long name
 * pkgname -r                  print relative path to package directory
 ******************************************************************************/
   
#include <sys/types.h>
#include <errno.h>
#include <malloc.h>
#include <unistd.h>
#include <string.h>

extern int errno;
char *getcwd();
char *get_working_directory();

/******************************************************************************/
/* main program
 ******************************************************************************/
main(argc,argv) int argc; char **argv;
{
char *name,*path,*symb,*basename,*p,*q;
int l=0,s=0,r=0,i;

name= *argv;

if (argc==1) {usage(name); return(-1);}

while (--argc>0) {
 argv++;
 if (!strcmp(*argv,"-l")) l=1;
 if (!strcmp(*argv,"-r")) r=1;
 if (!strcmp(*argv,"-s")) s=1;
 }

if (l+s+r != 1) { usage(name); return(-1); }

path=get_working_directory(name);

p=path; while (*p!='\0') p++;
i=0;
while (p-->path) {
 q=p+1;
 while (p>path && *p!='/') p--;
 *q='\0';
 if (i==0) basename=p+1;
 symb=index(p,'-');
 if (symb!=NULL) {
  if (s==1) {*symb='\0'; printf("%s\n",p+1); return(0);}
  if (l==1) {             printf("%s\n",p+1); return(0);}
  if (r==1) {printf("."); while(i>0) printf("/.."),i--; printf("\n");
             return(0);}
  }
  i++;
 }
 
if (r==1) printf(".\n"); else printf("%s\n",basename);
free(path);

}

/*****************************************************************************/
/* print usage info                                                          */
/*****************************************************************************/
usage(name) char *name;
 {
 printf("usage: %s {-l|-s|-r}\n", name);
 }

/*****************************************************************************/
/* get the name of the current working directory;                            */
/* allocate space for path name using malloc; revert to double buffer length */
/* if getcwd fails because the buffer was too short                          */
/*****************************************************************************/
char *get_working_directory(name) char *name;
 {
 int rc;
 char *path,*p;
 int maxl=255;

 rc=0;
 while (rc==0) {
  path=(char *)malloc(maxl);
  if (path==NULL) {
   printf("%s: cannot malloc space for path name\n",name);
   exit(-9);
   }
 
  p=getcwd(path,maxl);
  if (p!=NULL) rc=1;
  else {
   if (errno==ERANGE) {
    free(path);
    /* allocate more space for the path             */
    /* printf("getcwd failed with size=%d\n",maxl); */
    maxl*=2;
    }
   else rc=-1,printf("%s: [getcwd] errno=%d\n",name,errno);
   }
  }
 return(path);
 }
