
!********************************************************************************
!*   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
!*   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
!*   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
!*
!*
!*   This file is part of the package SNF.
!*
!*   SNF is free software; you can redistribute it and/or modify
!*   it under the terms of the GNU General Public License as published by
!*   the Free Software Foundation; either version 2 of the License, or
!*   (at your option) any later version.
!*
!*   This program is distributed in the hope that it will be useful,
!*   but WITHOUT ANY WARRANTY; without even the implied warranty of
!*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*   GNU General Public License for more details.
!*
!*   You should have received a copy of the GNU General Public License
!*   along with this program; if not, write to the Free Software
!*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
!*
!********************************************************************************
module snf_oldsubs
  !---------------------------------------------------------------------
  ! module which contains old subroutines, which are no longer needed
  ! in snf, but we don't dare to delete them.
  !
  ! written by J. Neugebauer, Uni Erlangen, 2001
  !---------------------------------------------------------------------
  use f90_kind
  use snf_error, only : serror
  private


  !***********************************************************************

  subroutine old_read_control(ctrl)
    use snf_tools, only: string2integer,string2real
    implicit none
    !----------------------------------------------------------------
    ! read all avaible data from control
    ! this routine is included only for compatibility mode
    !
    ! written by Carsten Kind, Uni Erlangen, 1999
    ! modified by Markus Reiher, Uni Erlangen, Aug. 2001
    ! removed from module snf_control by J. Neugebauer, 28.09.2001
    !----------------------------------------------------------------
    type(type_ctrl),intent(inout) :: ctrl
    character(len=132)          :: buf
    integer :: ucf
    ! --------- read whole control file  -------------------------
    ucf = 42
    buf='  '
    ctrl%symmetry='   '
    open(unit=ucf,file='control',status='unknown')
    do while(index(buf,'$end').eq.0)
       read(ucf,'(a)') buf
       if(index(buf,'$title ').ne.0) then
          read(ucf,'(a)') buf
          ctrl%title=trim(buf)
       else if( index(buf,'$cstep ').ne.0) then
          ctrl%cstep=string2real(buf)
          ctrl%tm_ctrl%cstep=ctrl%cstep
       else if( index(buf,'$symmetry ').ne.0) then
          ctrl%tm_ctrl%symmetry=trim(buf(11:))
       else if( index(buf,'$nf_symmetry ').ne.0) then
          ctrl%symmetry=trim(buf(14:))
       else if( index(buf,'$scfconv ').ne.0) then
          ctrl%scfconv=string2integer(buf)
          ctrl%tm_ctrl%scfconv=ctrl%scfconv
       else if( index(buf,'$scfinstab').ne.0.and.index(buf,'polly').ne.0) then
          ctrl%tm_ctrl%inputpol = 1
          ctrl%raman=.true.
       else if( index(buf,'$scfinstab').ne.0.and.index(buf,'dynpol').ne.0) then
          ctrl%tm_ctrl%inputpol = 2
          ctrl%raman=.true.
          ctrl%dynpol=.true.
       else if( index(buf,'$numderiv ').ne.0) then
          ctrl%numderiv=string2integer(buf)
          ctrl%tm_ctrl%numderiv=ctrl%numderiv
       else if( index(buf,'$ridft ').ne.0) then
          ctrl%mode=2
          ctrl%tm_ctrl%mode=2
       else if( index(buf,'$rimp2 ').ne.0) then
          ctrl%mode=3
          ctrl%tm_ctrl%mode=3
       else if( index(buf,'$coord ').ne.0) then
          ctrl%tm_ctrl%coord=trim(buf(index(buf,'=')+1:))
       endif
    enddo
    close(ucf)
    if(ctrl%raman.and.ctrl%mode.eq.2) then
       call serror('old_read_control',0,'No ridft available for Raman!##&
        &ridft is switched off.')
       ctrl%mode=1
       ctrl%tm_ctrl%mode=1
    endif
    if( ctrl%symmetry .eq. '   ') ctrl%symmetry=ctrl%tm_ctrl%symmetry
  end subroutine old_read_control
 
  !************************************************************************

end module snf_oldsubs
