
!********************************************************************************
!*   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
!*   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
!*   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
!*
!*
!*   This file is part of the package SNF.
!*
!*   SNF is free software; you can redistribute it and/or modify
!*   it under the terms of the GNU General Public License as published by
!*   the Free Software Foundation; either version 2 of the License, or
!*   (at your option) any later version.
!*
!*   This program is distributed in the hope that it will be useful,
!*   but WITHOUT ANY WARRANTY; without even the implied warranty of
!*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!*   GNU General Public License for more details.
!*
!*   You should have received a copy of the GNU General Public License
!*   along with this program; if not, write to the Free Software
!*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
!*
!********************************************************************************
program table_test
  !--------------------------------------------------------
  ! checks conformity of character tables with the 
  ! little orthogonality theorem (LOT)
  !
  ! written by C. Kind, Uni Erlangen, 2001
  !--------------------------------------------------------
  use snf_char_table,only : test_char_table
  implicit none
  character(len=3) :: symmgrps(45)
  integer :: i
  data symmgrps /'ci ','cs ','c2 ','c3 ','c4 ','c5 ','c6 ','c7 ','c8 ',&
       &         'c2v','c3v','c4v','c5v','c6v','c2h','c3h','c4h','c5h','c6h',&
       &         'd2 ','d3 ','d4 ','d5 ','d6 ','d2h','d3h','d4h','d5h','d6h',&
       &         'd2d','d3d','d4d','d5d','d6d','s4 ','s6 ','s8 ',&
       &         'c1 ','o  ','oh ','t  ','th ','td ','i  ','ih '/
  do i = 1,45
     write(*,*)
     write(*,*)'Test of pointgroup:', symmgrps(i)
     call test_char_table(symmgrps(i),6)
  enddo
end program table_test
