dnl BAH macro collection for autoconf
dnl V 2.11 - 120202   - BAH $(LAMHOME)
dnl V 2.10 - 170102   - CK added basic Fortran 90 support
dnl V 2.9  - 041001   - FLIBS
dnl V 2.8  - 040801   - set MPI, -D$osname
dnl V 2.7  - 02.04.00 - year 2000
dnl V 2.6  - 23.03.99 - OPENRECL fixed
dnl V 2.5  - 21.03.99 - test for $os_type enclosed in quotes
dnl V 2.4  - 04.02.99 - -DNOVAL
dnl V 2.3  - 24.01.99 - FOPT/COPT/CFLAGS/FFLAGS/LDFLAGS
dnl V 2.2  - 22.01.99 - --with-FC= --with-CC=, GETPARM needs 2 parameters now
dnl V 2.1  - 06.01.99 - test for g77 changed
dnl V 2.0  - 29.06.98 - USE_PRECONFIGURED_TEMPLATES
dnl V 1.18 - 10.06.98 - define ALPHA variable in F77_MACHINERY; F77_CONVERT
dnl V 1.17 - 06.01.98 - 1998; caching for GETPARM variables
dnl V 1.16 - 01.12.97 - G77 Makefile variable
dnl V 1.15 - 27.11.97 - getparm for variable GCC introduced
dnl V 1.14 - 24.11.97 - test for GNU F77 fixed
dnl V 1.13 - 08.11.97 - test for GNU F77
dnl V 1.12 - 02.09.97 - --with-pwr2 removed
dnl V 1.11 - 29.08.97 - new getparm syntax
dnl V 1.10 - 21.08.97 - $NOVAL configurable in PARM file
dnl V 1.9 - 22.04.97 - $LOCAL exported; tests for %val and dgemm fixed
dnl V 1.8 - 13.04.97 - local libs LOCAL which are not checked for
dnl V 1.7 - 14.03.97 - Linux changes for REPLACE
dnl V 1.6 - 01.03.97 - RECL in OPEN stmts
dnl V 1.5 - 14.02.97 - $host_os used to determine parameters
dnl V 1.4 - 10.02.97 - BAH_F77_GETPARM BAH_MYAUX
dnl V 1.3 - 5.8.96 check for ANSI/non-ANSI
dnl V 1.2 - 20.7.96 BAH_AUX relative path
dnl V 1.1 - 16.7.96 version numbers, OPT
dnl ************************************************************************
dnl macro to define variables holding the names of the files in a directory
dnl calling sequence:
dnl BAH_NAMES(full_var,stripped_var,directory)
dnl definition: BAH_NAMES(SRC,PROGS,src)
dnl V 1.0 - BAH 12.4.96
dnl ************************************************************************
AC_DEFUN(BAH_NAMES,
[
$1=
$2=
for i in $3/*
 do
 if test -d $i
 then
  j=`echo $i | sed s"+.*$3/++"`
  $2="$$2 $j"
  $1="$$1 $i"
 fi
done
])
dnl ************************************************************************
dnl macro to define binary directory for auxiliary routines (delrem,...)
dnl definition: BAH_F77_DIRECTORIES
dnl V 2.0 - BAH 28.06.98
dnl ************************************************************************
AC_DEFUN(BAH_F77_DIRECTORIES,
[
if test -z "$BAH_AUX"; then
test -s ../../../../../=PVNR= && BAH_AUX=../../../../../aux
test -s ../../../../=PVNR= && BAH_AUX=../../../../aux
test -s ../../../=PVNR= && BAH_AUX=../../../aux
test -s ../../=PVNR= && BAH_AUX=../../aux
test -s ../=PVNR= && BAH_AUX=../aux
test -z "$BAH_AUX" && BAH_AUX=aux
fi

if test ! -z "$DEBUG"; then echo DEBUG --- aclocal.m4: BAH_AUX=$BAH_AUX; fi

AC_CONFIG_AUX_DIR($BAH_AUX)
MVBIN=../../bin
X=
dnl template configuration; we are in subdirectory $TMPSCR
test ! -z "$TMPSCR" && X=../
test ! -d $X$MVBIN && MVBIN=.

if test -f Makefile.am; then
 TMPLCFG=mk.in
 TMPSCR=TMP_$$
 export TMPSCR
 mkdir $TMPSCR
 if test -f etc/distclean.mk.in; then
   cp etc/*.mk.in $TMPSCR
   $BAH_AUX/p_cfgmake Makefile
 else
  if test ! -f $BAH_AUX/bin/distclean.mk && \
     test ! -z "$USE_PRECONFIGURED_TEMPLATES"; then
   echo --- configuring standard makefile templates in $BAH_AUX ---
   cp $BAH_AUX/*.mk.in $TMPSCR
   cp $BAH_AUX/configure $TMPSCR
   cp $BAH_AUX/config.sub $TMPSCR
   RELAUX=$BAH_AUX
dnl get the absolute path name of $BAH_AUX
   BAH_AUX=`(cd $BAH_AUX > /dev/null; pwd)`
   export BAH_AUX
   (cd $TMPSCR; configure)
   cp $TMPSCR/*.mk $BAH_AUX/bin
   BAH_AUX=$RELAUX
  fi
  if test -f $BAH_AUX/bin/distclean.mk && \
     test ! -z "$USE_PRECONFIGURED_TEMPLATES"; then
   echo --- using preconfigured templates ---
   TMPLCFG=mk
   cp $BAH_AUX/bin/*.mk $TMPSCR
   $BAH_AUX/p_cfgmake -extension mk Makefile
  else
   test "$STANDALONE" = 1 && STANDALONE="-standalone"
   TMPLCFG=mk.in
   cp $BAH_AUX/*.mk.in $TMPSCR
   $BAH_AUX/p_cfgmake $STANDALONE Makefile
  fi
 fi
 rm -r $TMPSCR
fi
])

dnl ************************************************************************
dnl cache operating system name
dnl definition: BAH_OPSYS
dnl ************************************************************************
AC_DEFUN(BAH_OPSYS,
[
if test -z "$USE_PRECONFIGURED_TEMPLATES"; then
AC_CACHE_CHECK(operating system,
bah_cv_f77_os,
[
AC_CANONICAL_HOST
bah_cv_f77_os=$host_cpu-$host_vendor-$host_os
])
changequote(,)dnl
host_cpu=`echo $bah_cv_f77_os|sed -e 's/\\([^-]*\\)-.*/\\1/'`
host_vendor=`echo $bah_cv_f77_os|sed -e 's/[^-]*-\\([^-]*\\)-.*/\\1/'`
host_os=`echo $bah_cv_f77_os|sed -e 's/[^-]*-[^-]*-\\(.*\\)/\\1/'`
os_type=`echo $host_os|sed -e 's/\\([^0-9.]*\\)[0-9.]*/\\1/' | tr a-z A-Z`
osname=`echo $os_type|sed -e 's/\\(.*\\)-.*/\\1/'`
changequote([,])dnl
fi # if test -z "$USE_PRECONFIGURED_TEMPLATES"
])
dnl ************************************************************************
dnl set up variables for FORTRAN/C linkage
dnl definition: BAH_F77_CLINK
dnl following variables are set:
dnl CC                  name of C compiler
dnl BAH_AUXBIN          name of directory containing the above programs/scripts
dnl ************************************************************************
AC_DEFUN(BAH_F77_CLINK,
[
if test -z "$USE_PRECONFIGURED_TEMPLATES"; then
AC_ARG_WITH(CC,"--with-CC=C-compiler-name",CC=$withval,CC=)

if test -z "$CC"; then
 BAH_F77_GETPARM(CC,CC)
 if test -z "$CC"
 then
 AC_CHECK_PROGS(CC,cc gcc)
 fi
fi

test -z "$CC" && AC_MSG_ERROR(C compiler not found)

AC_MSG_CHECKING(if $CC is happy with ANSI prototypes)
AC_TRY_COMPILE(,[void xx(int)],have_ansi=yes,have_ansi=no)
AC_MSG_RESULT($have_ansi)
test $have_ansi = yes && AC_DEFINE(HAVE_ANSI_PROTOTYPES)

BAH_F77_GETPARM(CFLAGS,CFLAGS)

CFLAGS=$CFLAGS" "-D$osname

dnl
dnl try to find out if C subroutines need an underscore
dnl

AC_CACHE_CHECK(whether FORTRAN subroutines need an underscore,
bah_cv_f77_underscore,
[
C=conftest_BAH
cat > $C.f <<EOF
      CALL testxxx
      STOP
      END
EOF
cat > $C-.c <<EOF
testxxx() { return(0);}
EOF
$CC $CFLAGS -c $C-.c > /dev/null 2>&1
$FC $FFLAGS -o $C $C.f $C-.o > $C.out 2>&1
XX=$?
dnl test for returncode does not work on linux
test "$os_type" = LINUX && \
 test ! -z "`cat $C.out | grep testxxx_`" && XX=4
if test $XX -eq 0
then
bah_cv_f77_underscore=no
else
bah_cv_f77_underscore=yes
fi
rm $C*
])
if test $bah_cv_f77_underscore = no
then
AC_DEFINE(BAH_F77_UNDERSCORE,0)
else
AC_DEFINE(BAH_F77_UNDERSCORE,1)
CFLAGS="$CFLAGS -DUNDERSCORE"
fi

AC_SUBST(CC)
AC_SUBST(CFLAGS)
fi # USE_PRECONFIGURED_TEMPLATES
])
dnl ************************************************************************
dnl set up libraries
dnl definition: BAH_F77_LIBS
dnl ************************************************************************
AC_DEFUN(BAH_F77_LIBS,
[
AC_CACHE_CHECK(libraries,bah_cv_f77_libs,
[
 BAH_F77_GETPARM($2,$1)
 C=conftest_BAH
 cat > $C.f <<EOF
      I=1
      STOP
      END
EOF
 if test ! -z "$3"; then
  test ! -z "${$1}" && echo $ac_n checking $1 libraries ... $ac_c
  for i in ${$1}
  do
   X=`echo $i | sed 's+-l++'`
   #echo $ac_n $i ... $ac_c
   j=`eval echo $i`
   $FC $FOPT -o $C $C.f $j > conftest_BAH.out 2>&1
   if test -z "`cat conftest_BAH.out | grep $X`"
   then
   #echo yes $ac_c
   bah_cv_f77_libs="$bah_cv_f77_libs $i"
   #else
   #echo no $ac_c
   fi
  done
 fi
 rm $C*
])

LIBS="$bah_cv_f77_libs"
dnl echo LIBS=$LIBS

AC_SUBST(LIBS)
AC_SUBST(LOCAL)
])
dnl ************************************************************************
dnl set up variables for FORTRAN compilation
dnl definition: BAH_F77_MACHINERY
dnl required variables:
dnl BAH_AUX             name of directory hosting the delrem directory
dnl following variables are set:
dnl FC                  name of FORTRAN compiler
dnl DELREM              name of delrem executable
dnl RVERS               name of the rvers script
dnl all these programs/scripts are generated from their sources
dnl unless they exist in directory $BAH_AUX/bin
dnl BAH_AUXBIN          name of directory containing the above programs/scripts
dnl ************************************************************************
AC_DEFUN(BAH_F77_MACHINERY,
[
BAH_F77_DIRECTORIES

if test -z "$USE_PRECONFIGURED_TEMPLATES"; then

GOTOPTS=

AC_ARG_WITH(FC,"--with-FC=compilername",FC=$withval,FC=)

dnl see if a default is specified for this OS or this machine in PARM file
if test -z "$FC"; then
BAH_F77_GETPARM(FC,FC)
fi


if test -z "$FC"; then
AC_CHECK_PROGS(FC,f90 lf95 pgf90 f77 frt g77)
else
 if test -s $BAH_AUX/getparm; then
  GOTOPTS=1
  BAH_F77_GETPARM(${FC}FLAGS,FFLAGS)
  BAH_F77_GETPARM(${FC}OPT,FOPT)
  BAH_F77_GETPARM(${FC}STATIC,STATIC)
  BAH_F77_GETPARM(${FC}LDFLAGS,LDFLAGS)
  BAH_F77_GETPARM(${FC}LIBS,FLIBS)
 fi
fi

test -z "$FC" && AC_MSG_ERROR(FORTRAN compiler not found)

DELREM=
test -f $BAH_AUX/delrem/rvers && cp $BAH_AUX/delrem/rvers $BAH_AUX/bin
test -f $BAH_AUX/bin/delrem && DELREM=$BAH_AUX/bin/delrem
# maybe that we are in $BAH_AUX/delrem directory; then DELREM may be dummy
test -f delrem.r && DELREM=echo
test -z "$DELREM" && \
(D=$BAH_AUX/delrem; echo -- compiling delrem in $D --; \
 cd $D; configure; make) && DELREM=$BAH_AUX/bin/delrem


BAH_AUXBIN=$BAH_AUX/bin

dnl
dnl find out appropriate compiler options for the FORTRAN compiler
dnl

if test -s $BAH_AUX/getparm; then

 G77=
 if test ! -z "`$FC -v 2>&1 | grep 'g77'`"; then
  AC_DEFINE(G77,1)
  BAH_F77_GETPARM(g77FLAGS,FFLAGS)
  BAH_F77_GETPARM(g77OPT,FOPT)
  BAH_F77_GETPARM(g77STATIC,STATIC)
  BAH_F77_GETPARM(g77LDFLAGS,LDFLAGS)
  BAH_F77_GETPARM(${FC}LIBS,FLIBS)
  FFLAGS="$FFLAGS -Dg77"
  GOTOPTS=1
 else
  AC_DEFINE(G77,0)
 fi
 if test -z "$GOTOPTS"; then
  BAH_F77_GETPARM(FFLAGS,FFLAGS)
  BAH_F77_GETPARM(FOPT,FOPT)
  BAH_F77_GETPARM(STATIC,STATIC)
  BAH_F77_GETPARM(LDFLAGS,LDFLAGS)
  BAH_F77_GETPARM(LIBS,FLIBS)
 fi
 
 BAH_F77_GETPARM(LD,LD)
fi

dnl operating system flags
if test "$os_type" = "OSF"; then
 AC_DEFINE(ALPHA,1)
else
 AC_DEFINE(ALPHA,0)
fi

dnl
dnl parallel stuff
dnl provide flags for native MPI (environment variable MPI set)
dnl

PAR=
if test "$WITH_MPI" = 1; then
 PAR=MPI
 PARLIBS="-lmpi"
fi

if test "$WITH_LAM" = 1; then
 PAR=MPI
 FFLAGS=$FFLAGS' -I$(LAMHOME)/include'
 PARLIBS='-L $(LAMHOME)/lib -llamf77mpi -lmpi -llam'
fi

if test "$WITH_MPICH" = 1; then
 PAR=MPI
 FFLAGS=$FFLAGS' -I$(MPICH)/include'
 PARLIBS='-L $(MPICH)/lib -lmpich'
 if test "$os_type" = IRIX; then
  IRIX_MPI_FFLAGS="-64"
 fi
fi

if test "$PAR" = MPI
then
 AC_DEFINE(BAH_F77_MPI,1)
fi

if test "$WITH_PVM" = 1
then
 PARLIBS='-L$(PVM_ROOT)/lib/$(PVM_ARCH) -lfpvm3 -lpvm3'
 FFLAGS=$FFLAGS' -I$(PVM_ROOT)/include'
fi

AC_SUBST(BAH_AUX)
AC_SUBST(BAH_AUXBIN)
AC_SUBST(IRIX_MPI_FFLAGS)
AC_SUBST(LD)
AC_SUBST(FFLAGS)
AC_SUBST(LDFLAGS)
AC_SUBST(FLIBS)
AC_SUBST(PARLIBS)
AC_SUBST(G77)
AC_SUBST(MVBIN)
AC_SUBST(PROGS)
AC_SUBST(TESTS)
AC_SUBST(STATIC)
AC_SUBST(DELREM)
AC_SUBST(RVERS)
AC_SUBST(ALPHA)
fi # USE_PRECONFIGURED_TEMPLATES
])
dnl ************************************************************************
dnl define a AC_SUBST variable from PARM database
dnl definition: BAH_F77_GETPARM(PARM_TAG,variable)
dnl required variables:
dnl BAH_AUX             name of directory hosting the delrem directory
dnl ************************************************************************
AC_DEFUN(BAH_F77_GETPARM,
[
AC_CACHE_CHECK(for $1 in $BAH_AUX/PARM,
bah_cv_f77_PARM_$2,
[
X=`$BAH_AUX/getparm -aux $BAH_AUX os=$os_type $BAH_AUX/PARM $1`
X=`eval echo $X`
bah_cv_f77_PARM_$2=$X
])
X=$bah_cv_f77_PARM_$2
$2=$X
if test -z "$X"; then
AC_DEFINE($2,0)
else
AC_DEFINE($2,1)
fi
AC_SUBST($2)
])
dnl ************************************************************************
dnl macro to check if FORTRAN knows about an intrinsic function
dnl definition: BAH_F77_REPLACE_FUNC(fct_name,typical_statement_using_fct)
dnl example: BAH_F77_REPLACE_FUNC(ior,i=ior(j,k))
dnl V 1.0 - BAH 12.4.96
dnl ************************************************************************
AC_DEFUN(BAH_F77_REPLACE_FUNC,
[
AC_CACHE_CHECK(for FORTRAN function $1,
bah_cv_f77_$1,
[
C=conftest_BAH
cat > $C.f <<EOF
      $2
      STOP
      END
EOF
LL=`eval echo $LIBS`
$FC $FOPT -o $C $C.f $LL > conftest_BAH.out 2>&1
XX=$?
dnl test for returncode does not work on linux
if test "$os_type" = LINUX
then
 if test ! -z "`cat conftest_BAH.out | grep $C`"
 then
  XX=4
 fi
fi
if test $XX -eq 0
then
bah_cv_f77_$1=yes
else
bah_cv_f77_$1=no
fi
rm $C*
])
test $bah_cv_f77_$1 = no && LIBOBJS="$LIBOBJS $1.o"
])
dnl ***************************************************************************
dnl macro to check if FORTRAN knows about a subroutine
dnl definition: BAH_F77_REPLACE_SUBR(subroutine_name)
dnl example: BAH_F77_REPLACE_SUBR(dnrm2)
dnl V 1.0 - BAH 12.4.96
dnl ************************************************************************
AC_DEFUN(BAH_F77_REPLACE_SUBR,
[
AC_CACHE_CHECK(for FORTRAN subroutine $1,
bah_cv_f77_$1,
[
if test ! -z "$LIBS"; then
 C=conftest_BAH
 cat > $C.f <<EOF
      CALL $1
      STOP
      END
EOF
 LL=`eval echo $LIBS`
 $FC $FOPT -o $C $C.f $LL > conftest_BAH.out 2>&1
 XX=$?
 dnl test for returncode does not work on linux
 if test "$os_type" = LINUX
 then
  if test ! -z "`cat conftest_BAH.out | grep $C`"
  then
   XX=4
  fi
 fi
 if test $XX -eq 0
 then
 bah_cv_f77_$1=yes
 else
 bah_cv_f77_$1=no
 fi
 rm $C*
else
 bah_cv_f77_$1=no
fi
])
if test $bah_cv_f77_$1 = no
then
LIBOBJS="$LIBOBJS $1.o"
fi
])
dnl ***************************************************************************
dnl macro to check if FORTRAN knows about a subroutine
dnl if yes, the variable BAH_F77_HAVE_subroutine will be defined
dnl definition: BAH_F77_HAVE_SUBR(subroutine_name)
dnl example: BAH_F77_HAVE_SUBR(dger)
dnl V 1.0 - BAH 12.4.96
dnl ************************************************************************
AC_DEFUN(BAH_F77_HAVE_SUBR,
[
AC_CACHE_CHECK(for FORTRAN subroutine $1,
bah_cv_f77_$1,
[
C=conftest_BAH
cat > $C.f <<EOF
      CALL $1
      STOP
      END
EOF
LL=`eval echo $LIBS`
$FC $FOPT -o $C $C.f $LL > conftest_BAH.out 2>&1
XX=$?
dnl test for returncode does not work on linux
if test "$os_type" = LINUX
then
 if test ! -z "`cat conftest_BAH.out | grep $C`"
 then
  XX=4
 fi
fi
if test $XX -eq 0
then
bah_cv_f77_$1=yes
else
bah_cv_f77_$1=no
fi
rm $C*
])
BAH_NAME=BAH_F77_HAVE_`echo $1 | tr a-z A-Z`
if test $bah_cv_f77_$1 = yes
then
AC_DEFINE_UNQUOTED($BAH_NAME,1)
else
AC_DEFINE_UNQUOTED($BAH_NAME,0)
fi
])
dnl ************************************************************************
dnl macro to generate file src/adapted.inc
dnl definition: BAH_VERSION
dnl example: BAH_VERSION(MOLCAS-2)
dnl ************************************************************************
AC_DEFUN(BAH_VERSION,
[
v=`pwd`
v=`basename $v`
echo \ \ \ \ \ \ Write \(*,*\) > src/adapted.inc
echo \ \ \ \ \ \ Write \(*,*\) \"$1 - $v\" \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ Write \(*,*\) \"portable UNIX Version\" \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ WRITE \(*,*\) \"University of Erlangen \(Germany\), \(C\) 2000\"  \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ WRITE \(*,*\) \"`date`\" \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ Write \(*,*\) \"configured for $c [`hostname`]\" \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ Write \(*,*\) \"`$BAH_AUX/config.guess`\" \
                                               >> src/adapted.inc
echo \ \ \ \ \ \ Write \(*,*\)                 >> src/adapted.inc
])
dnl ************************************************************************
dnl definition: BAH_MKFUNC($1,$2)
dnl on the first call, a makefile label $1 will be created
dnl on further calls, a line (cd $1; $2) is added dnl if $2 is empty, the file will be written to $1 unless $1 ends with
dnl a colon. In this case, a new makefile target will be written
dnl ************************************************************************
AC_DEFUN(BAH_MKFUNC,
[
if test -z "$BAH_mkfunc"
then
 BAH_mkfunc=conftest_BAH_mkfunc
 echo $1 > $BAH_mkfunc
else
 if test -z "$2"
 then
  if test -z "`echo $1 | grep ':$'`"
  then
   sed 's+XXX+	+' $BAH_mkfunc > $1
   rm $BAH_mkfunc
   BAH_mkfunc=
  else
   echo $1 >> $BAH_mkfunc
  fi
 else
  for d in $1
  do
   echo XXX-\(if test -d $d\; then cd $d\; $2\; fi\) >> $BAH_mkfunc
  done
 fi
fi
])
dnl ************************************************************************
dnl definition: BAH_WITH(key_name,variable_name)
dnl example: BAH_WITH(large-core,BAH_F77_LARGECORE)
dnl ************************************************************************
AC_DEFUN(BAH_WITH,
[
AC_ARG_WITH($1,"--with-$1",
$2=1;BAH_CONFIGURE_FLAGS="$BAH_CONFIGURE_FLAGS --with-$1";AC_DEFINE($2,1),
$2=0;BAH_CONFIGURE_FLAGS="$BAH_CONFIGURE_FLAGS --without-$1";AC_DEFINE($2,0))
])
dnl ************************************************************************
dnl definition: BAH_F77_ADDLIB,
dnl add a library name to the LIBS string
dnl $1        a user supplied library file name
dnl $2        the name of the system library that should be used if $1 is
dnl $3        a subroutine that should be present in $2
dnl           not present
dnl ************************************************************************
AC_DEFUN(BAH_F77_ADDLIB,
[
if test -s $1 && test ! -z "`ar tv $1`"
then
LIBS="$LIBS $1"
else
if test ! -z "$2"; then
AC_CHECK_LIB($2,$3,LIBS="$LIBS -l$2")
fi
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_INTEGER1
dnl ************************************************************************
AC_DEFUN(BAH_F77_INTEGER1,
[
C=conftest_BAH
AC_CACHE_CHECK(whether INTEGER*1 is known,bah_cv_f77_integer1,
[
cat > $C.f <<EOF
      INTEGER*1 i
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > /dev/null 2>&1
if test $? -eq 0
then
bah_cv_f77_integer1=yes
else
bah_cv_f77_integer1=no
fi
rm $C*
])
if test $bah_cv_f77_integer1 = yes
then
AC_DEFINE(BAH_F77_LOGICAL1,0)
else
AC_DEFINE(BAH_F77_LOGICAL1,1)
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_REAL16
dnl ************************************************************************
AC_DEFUN(BAH_F77_REAL16,
[
C=conftest_BAH
AC_CACHE_CHECK(whether REAL*16 is known,bah_cv_f77_real16,
[
cat > $C.f <<EOF
      REAL*16 i
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > conftest_BAH.out 2>&1
XX=$?
if test $XX -eq 0
then
bah_cv_f77_real16=yes
else
bah_cv_f77_real16=no
fi
rm $C*
])
if test $bah_cv_f77_real16 = yes
then
AC_DEFINE(BAH_F77_NOREAL16,0)
AC_DEFINE(HAVE_REAL16,1)
else
AC_DEFINE(BAH_F77_NOREAL16,1)
AC_DEFINE(HAVE_REAL16,0)
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_BYTE
dnl ************************************************************************
AC_DEFUN(BAH_F77_BYTE,
[
C=conftest_BAH
AC_CACHE_CHECK(whether byte is a valid type,bah_cv_f77_byte,
[
cat > $C.f <<EOF
      BYTE i(8)
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > conftest_BAH.out 2>&1
XX=$?
if test "$os_type" = LINUX
then
 if test ! -z "`cat conftest_BAH.out | grep -i error`"
 then
  XX=4
 fi
fi
if test $XX -eq 0
then
bah_cv_f77_byte=yes
else
bah_cv_f77_byte=no
fi
rm $C*
])
if test $bah_cv_f77_byte = yes
then
AC_DEFINE(BAH_F77_RPLBYTE,0)
else
AC_DEFINE(BAH_F77_RPLBYTE,1)
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_VAL
dnl ************************************************************************
AC_DEFUN(BAH_F77_VAL,
[
C=conftest_BAH
AC_CACHE_CHECK(whether %val(.) can be used,bah_cv_f77_val,
[
bah_cv_f77_val=no
echo $FFLAGS | grep DNOVAL > /dev/null 2>&1
XX=$?
if test "$XX" -eq 1; then
BAH_F77_GETPARM(NOVAL,NOVAL)
if test ! -z "$NOVAL"
then
# NOVAL configured from PARM file
 echo NOVAL=$NOVAL in PARM file ...
 if test "$NOVAL" != 1
 then
  bah_cv_f77_val=yes
 fi
else
# check if %val(.) is accepted
cat > $C.f <<EOF
      CALL sqrt(%val(0))
      STOP
      END
      SUBROUTINE sqrt
      END
EOF
$FC $FOPT -o $C $C.f > conftest_BAH.out 2>&1
XX=$?
if test "$os_type" = LINUX
then
 if test ! -z "`cat conftest_BAH.out | grep -i error`"
 then
  XX=4
 fi
fi
fi # if FFLAGS specifies -DNOVAL
if test $XX -eq 0
then
bah_cv_f77_val=yes
else
bah_cv_f77_val=no
fi
rm $C*
])
if test "$bah_cv_f77_val" = yes
then
AC_DEFINE(BAH_F77_NOVAL,0)
else
AC_DEFINE(BAH_F77_NOVAL,1)
fi
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_DGEMM_LIBOK(library)
dnl ************************************************************************
AC_DEFUN(BAH_F77_DGEMM_LIBOK,
[
C=conftest_BAH

AC_CACHE_CHECK(if we have a working dgemm,bah_cv_f77_dgemm_there,
[
if test ! -z "$1" && test "$1" != " "
then
echo -n in $1 ...
cat > $C.f <<EOF
      DIMENSION A(2,3),B(3,4),C(2,4)
      DATA A /1.D0, 2.D0, 3.D0, 4.D0, 5.D0, 6.D0/
      DATA B /1.D0, 2.D0, 3.D0, 4.D0, 5.D0, 6.D0,
     *10.D0, 20.D0, 30.D0, 40.D0, 50.D0, 60.D0/
      CALL DGEMM ('N','N', 2, 4, 3, 1.D0, A, 2, B, 3, 0.0D0, C, 2)
      WRITE (*,*) C(1,2)
      IF (DABS(C(1,2)-13.D0) .GT. 1.D-6) STOP 4
      STOP
      END
EOF
 $FC $FOPT -o $C $C.f $1 > /dev/null 2>&1
 if test $? -eq 0
 then
 bah_cv_f77_dgemm_there=yes
 else
 bah_cv_f77_dgemm_there=no
 fi
 rm $C*
else
 bah_cv_f77_dgemm_there=no
fi
])
if test $bah_cv_f77_dgemm_there = yes
then
AC_DEFINE(BAH_F77_LIBOK_DGEMM,1)
else
AC_DEFINE(BAH_F77_LIBOK_DGEMM,0)
LIBOBJS="$LIBOBJS dgemm.o"
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_ZHEX
dnl ************************************************************************
AC_DEFUN(BAH_F77_ZHEX,
[
C=conftest_BAH

AC_CACHE_CHECK(for Z format in DATA statements,bah_cv_f77_zhex,
[
cat > $C.f <<EOF
      DATA A /Z01010101/
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > conftest_BAH.out 2>&1
XX=$?
if test "$os_type" = LINUX
then
 if test ! -z "`cat conftest_BAH.out | grep -i error`"
 then
  XX=4
 fi
fi
if test $XX -eq 0
then
bah_cv_f77_zhex=yes
else
bah_cv_f77_zhex=no
fi
rm $C*
])
if test $bah_cv_f77_zhex = yes
then
AC_DEFINE(BAH_F77_HEX,0)
else
AC_DEFINE(BAH_F77_HEX,1)
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_OPENBIGEND
dnl ************************************************************************
AC_DEFUN(BAH_F77_OPENBIGEND,
[
C=conftest_BAH

AC_CACHE_CHECK(whether OPEN accepts the CONVERT='BIG_ENDIAN' keyword,bah_cv_f77_openconvert,
[
cat > $C.f <<EOF
      OPEN (UNIT=1,STATUS='UNKNOWN',CONVERT='BIG_ENDIAN')
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > /dev/null 2>&1
if test $? = 0
then
bah_cv_f77_openconvert=yes
else
bah_cv_f77_openconvert=no
fi
rm $C*
])
if test $bah_cv_f77_openconvert = yes
then
AC_DEFINE(BAH_F77_OPEN_CONVERT_BIG_ENDIAN,0)
else
AC_DEFINE(BAH_F77_OPEN_CONVERT_BIG_ENDIAN,1)
fi
])
dnl ************************************************************************
dnl definition: BAH_F77_CLOSEDISPOK
dnl ************************************************************************
AC_DEFUN(BAH_F77_CLOSEDISPOK,
[
C=conftest_BAH

AC_CACHE_CHECK(whether CLOSE accepts the STATUS keyword,bah_cv_f77_closestatus,
[
cat > $C.f <<EOF
      CLOSE (UNIT=1,STATUS='DELETE')
      STOP
      END
EOF
$FC $FOPT -o $C $C.f > /dev/null 2>&1
if test $? = 0
then
bah_cv_f77_closestatus=yes
else
bah_cv_f77_closestatus=no
fi
rm $C*
])
if test $bah_cv_f77_closestatus = yes
then
AC_DEFINE(BAH_F77_CLOSEDISP,0)
else
AC_DEFINE(BAH_F77_CLOSEDISP,1)
fi
])
dnl ***************************************************************************
dnl macro to check if the specified libraries are non-empty; the non-empty
dnl libraries are include in variable MYLIBS
dnl definition: BAH_F77_MYLIBS(prefix,lib1 lib2 ...)
dnl example: BAH_F77_HAVE_SUBR(../../lib,essl blas lapack)
dnl V 1.0 - BAH 24.7.96
dnl ************************************************************************
AC_DEFUN(BAH_F77_MYLIBS,
[
AC_CACHE_CHECK(for local libs,bah_cv_f77_mylibs,
[
for i in $2
do
dnl test ! -z "`ar tv $1/lib$i.a`" && MYLIBS="$MYLIBS $1/lib$i.a"
MYLIBS="$MYLIBS $1/lib$i.a"
done
bah_cv_f77_mylibs=$MYLIBS
])
MYLIBS=$bah_cv_f77_mylibs
AC_SUBST(MYLIBS)
])

dnl ************************************************************************
dnl definition: BAH_F77_OPENRECL
dnl ************************************************************************
AC_DEFUN(BAH_F77_OPENRECL,
[
C=conftest_BAH

AC_CACHE_CHECK(unit to which OPEN RECL refers,bah_cv_f77_openrecl,
[
cat > $C.f <<EOF
      INTEGER ii(2)
      ii(1)=1
      ii(2)=2
      OPEN (UNIT=1,ACCESS='DIRECT',RECL=2,FILE='TMP.autoconf_bah')
      WRITE (1,REC=1,ERR=11) ii
11    ii(1)=0
      ii(2)=0
      READ (1,REC=1,ERR=10) ii
10    CONTINUE
      WRITE (*,*) ii(2)
      IF (ii(2).NE.2) STOP 1
      STOP 0
      END
EOF
$FC $FOPT -o $C $C.f > /dev/null 2>&1
$C > $C.out 2>&1
if test ! -z "`cat $C.out | grep 2`"
then
bah_cv_f77_openrecl=words
else
bah_cv_f77_openrecl=bytes
fi
rm $C* TMP.autoconf_bah
])
if test $bah_cv_f77_openrecl = words
then
AC_DEFINE(BAH_F77_RECLWORDS,1)
else
AC_DEFINE(BAH_F77_RECLWORDS,0)
fi
])




AC_DEFUN(CK_F90_MACHINERY,
[
BAH_F77_DIRECTORIES

if test -z "$USE_PRECONFIGURED_TEMPLATES"; then

AC_ARG_WITH(f90,"--with-f90=F90-Compiler name",F90=$withval,F90=)
AC_ARG_ENABLE(debug,--enable-debug for debugging usw., DEBUG=yes,DEBUG=no)
AC_ARG_ENABLE(prof,--enable-prof for profiling usw., PROFILE=yes,PROFILE=no)

if test ! -z "$F90" ; then
  AC_CHECK_PROGS(F90,$F90)
fi

#dnl see if a default is specified for this OS or this machine in PARM file
#if test -z "$F90" ; then
#  BAH_F77_GETPARM(F90,F90)
#fi

GOTOPTS2=
if test -z "$F90"; then
  AC_CHECK_PROGS(F90,f90 pgf90 lf95 ifc90 fort)
else
 if test -s $BAH_AUX/getparm; then
  GOTOPTS2=1
  BAH_F77_GETPARM(${F90}FLAGS,F90FLAGS)
  BAH_F77_GETPARM(${F90}OPT,F90OPT)
  BAH_F77_GETPARM(${F90}STATIC,STATIC)
  BAH_F77_GETPARM(${F90}LDFLAGS,LD90FLAGS)
  BAH_F77_GETPARM(${F90}LIBS,F90LIBS)
 fi
fi

if test -z "$GOTOPTS2"; then
  BAH_F77_GETPARM(${F90}FLAGS,F90FLAGS)
  BAH_F77_GETPARM(${F90}OPT,F90OPT)
  BAH_F77_GETPARM(${F90}STATIC,STATIC)
  BAH_F77_GETPARM(${F90}LDFLAGS,LD90FLAGS)
  BAH_F77_GETPARM(${F90}LIBS,F90LIBS)
fi

if test -z "$F90" ; then
   AC_MSG_ERROR(FORTRAN90 compiler not found)
fi

CK_F90_TRY_COMPILE

test  "$ck_cv_f90_run" = no && AC_MSG_ERROR(FORTRAN90 does not work with these options)

AC_SUBST(F90)
AC_SUBST(F90FLAGS)
AC_SUBST(F90OPT)
AC_SUBST(LD90FLAGS)
AC_SUBST(F90LIBS)
AC_SUBST(STATIC)
fi # USE_PRECONFIGURED_TEMPLATES
])

AC_DEFUN(CK_F90_TRY_COMPILE,
[
  C=conftest_CK
  AC_CACHE_CHECK(whether $F90 compiles,ck_cv_f90_compiles,
  [
  cat > $C.f90 << EOF
  program $C
    integer :: a(3),b(3),c
    a(:)=1
    b(:)=2
    c=dot_product(a,b)
    if (c .ne. 8) then
      stop 'ERROR'
    endif
  end program $C
EOF
  $F90 $F90FLAGS $F90OPT -o $C $C.f90 > /dev/null 2>&1
  if test $? -eq 0 ; then
    ck_cv_f90_compiles="yes"
  else
    ck_cv_f90_compiles="no"
  fi
  ])
  AC_CACHE_CHECK(whether $F90 binary runs,ck_cv_f90_run,
  [
  $C > /dev/null 2>&1
  if test $? -eq 0 ; then
    ck_cv_f90_run="yes"
  else
    ck_cv_f90_run="no"
  fi
  rm $C*
  ])
])
