CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE fsys(stepfl)
      INCLUDE 'defs.h'
**
** nonblocking receive for fsys records and for stop records
**
      INCLUDE 'comm.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INCLUDE 'strctok.h'
      INTEGER needans
      INTEGER stepfl(*)
      PARAMETER (needans=600)
      INTEGER p,ibuf,info,ilen,i,j,ist,ien,now,last,nodf
      INTEGER*4 irc4,icase4,ilen4,tid4,pid4
      CHARACTER*255 text
      CHARACTER*24 date
      CHARACTER*40 name
      REAL*8 getreal,loadav
C#    INTEGER st(MPI_STATUS_SIZE)
C#    INTEGER w,icase,icall,itype
C#    LOGICAL flag
C#    DATA w /MPI_COMM_WORLD/
      CALL secs(now)

88    CONTINUE
C//SKIPC#
      CALL PVMFNRECV(-1,BAHFSYSCAL,ibuf)
      IF (ibuf.NE.0) THEN
       CALL PVMFUNPACK(INTEGER4,tid4,1,1,info)
       CALL PVMFUNPACK(INTEGER4,pid4,1,1,info)
       CALL PVMFUNPACK(INTEGER4,irc4,1,1,info)
       CALL PVMFUNPACK(INTEGER4,icase4,1,1,info)
       CALL PVMFUNPACK(INTEGER4,ilen4,1,1,info)
       ilen=ilen4
       CALL PVMFUNPACK(STRING,text,ilen,1,info)
       i=tid4
C//END
C#    CALL MPI_IPROBE(MPI_ANY_SOURCE,fsys_mpitag,w,flag,st,info)
C#    CALL mpierr('MPI_PROBE','fsys',info)
C#    IF (flag) THEN
C#     CALL MPI_RECV(icall,1,MPI_INTEGER,MPI_ANY_SOURCE,
C#   *  fsys_mpitag,w,st,info)
C#     CALL mpierr('MPI_RECV icall','fsys',info)
C#     tid4=icall
C#     i=icall

* receive call type
C#     CALL MPI_RECV(itype,1,MPI_INTEGER,i,501,w,st,info)
C#     CALL mpierr('MPI_RECV type','fsys',info)

C#     IF (itype.EQ.fsys_mnotify) THEN
C#      CALL MPI_RECV(j,1,MPI_INTEGER,i,502,w,st,info)
C#      CALL mpierr('MPI_RECV pid','fsys',info)
C#      pid4=j
C#      CALL MPI_RECV(j,1,MPI_INTEGER,i,503,w,st,info)
C#      CALL mpierr('MPI_RECV irc','fsys',info)
C#      irc4=j
C#      CALL MPI_RECV(j,1,MPI_INTEGER,i,504,w,st,info)
C#      CALL mpierr('MPI_RECV icase','fsys',info)
C#      icase4=j
C#      CALL MPI_RECV(j,1,MPI_INTEGER,i,505,w,st,info)
C#      CALL mpierr('MPI_RECV len','fsys',info)
C#      ilen4=j
C#      CALL clean(text)
C#      CALL MPI_RECV(text,j,MPI_CHARACTER,i,506,w,st,info)
C#      CALL mpierr('MPI_RECV cmd','fsys',info)
C#      ilen4=j
C#      ilen=ilen4
       CALL sadmch_ftid(i)
       IF (cmch.EQ.0) THEN
        WRITE (*,102) 'FSYS ',info,tid4,pid4,irc4,icase4,
     *   ' ',text(1:ilen4)
        WRITE (*,*) '###### unknown tid: ',tid4
        CALL sadmch_dmp(jtape,pmch)
        GOTO 88
       ENDIF
       p=cmch
       is(p+sadmch_tmsg)=now

       IF (icase4.EQ.1) THEN
        is(p+sadmch_tpid)=pid4
        is(p+sadmch_trc )=0
       ELSE IF (icase4.EQ.3) THEN
*
* average load reporting
*
        ist=1
        loadav=getreal(text,ist,ien)
        is(p+sadmch_load)=DINT(100.D0*loadav)
        is(p+sadmch_trc )=DINT(100.D0*loadav)
        is(p+sadmch_tmsg)=now
       ELSE IF (icase4.EQ.4) THEN
*
* cpu time reporting
*
        CALL sadmch_spmsg(p,text(1:ilen))
       ELSE IF (icase4.EQ.6) THEN
*
* reporting debugging messages
*
        WRITE (idbg,*) '::: tid ',tid4,' pid ',pid4,' rc ',irc4,' waiting ',
     *   ctok_n
        WRITE (idbg,*) text(1:ilen4)
       ELSE IF (icase4.EQ.7) THEN
*
* request ctoken
*
        CALL areqctok(tid4,pid4)
       ELSE IF (icase4.EQ.8) THEN
*
* release ctoken
*
        CALL arelctok(tid4,pid4)
       ELSE IF (icase4.EQ.9) THEN
*
* node ready message (not used at present)
*
        WRITE (idbg,*) '::: tid ',tid4,irc4,text(1:ilen4)
*       IF (irc4.EQ.okok) THEN
*        is(p+sadmch_nodefl)=sadmch_rdy
*       ELSE
*        is(p+sadmch_nodefl)=sadmch_unf
*       ENDIF
       ELSE IF (icase4.EQ.2) THEN
        CALL sadmch_spmsg(p,' ')
        is(p+sadmch_tpid)=0
        is(p+sadmch_trc )=irc4
       ELSE
        CALL sadmch_spmsg(p,text(1:ilen))
        is(p+sadmch_trc )=irc4*10000+icase4
       ENDIF
       IF (iprintf.GT.0) WRITE (*,102) 'FSYS ',
     *  info,tid4,pid4,irc4,icase4,' ',text(1:ilen4)
102        FORMAT(A,5I10,2A)
       GOTO 88
      ENDIF

** check for stop records
**
C//SKIPC#
       CALL PVMFNRECV(-1,BAHTASKSTOP,ibuf)
       IF (ibuf.NE.0) THEN
        CALL PVMFUNPACK(INTEGER4,tid4,1,1,info)
        CALL PVMFUNPACK(INTEGER4,irc4,1,1,info)
        IF (tid4.EQ.0) THEN
         WRITE (*,*) 'PvmTaskExit received tid 0'
         CALL shutdown
        ENDIF
C//END
C#     IF (itype.EQ.fsys_taskstop) THEN
C#      CALL MPI_RECV(j,1,MPI_INTEGER,i,601,w,st,info)
C#      CALL mpierr('MPI_RECV irc','fsys',info)
C#      irc4=j
        CALL fdate(date)
        CALL sadmch_ftid(i)
        IF (cmch.EQ.0) THEN
         WRITE (*,102) 'FSYS ',info,tid4,irc4,' ',text(1:ilen4)
         CALL sadmch_dmp(jtape,pmch)
         WRITE (*,*) '###### unknown tid: ',tid4
         GOTO 88
        ENDIF
        CALL remnode(p,'node stopped',irc4,stepfl)
        GOTO 88
       ENDIF
C#     ENDIF

C//SKIPC+                         skip in case of SMP machines
*
* check if a node dis not answer for more then <needans> seconds
*
       p=pmch
10     IF (p.EQ.0) GOTO 11
       last=is(p+sadmch_tmsg)
       nodf=is(p+sadmch_nodf)
       IF (nodf.EQ.sadmch_runn.AND. last.NE.0) THEN
        IF (now-last.GT.needans) THEN
         CALL sadmch_gname(p,name)
         WRITE (*,*) name(1:8),' did not answer for ',needans,
     *    ' seconds.'
         WRITE (*,*) 'terminating node'
         is(p+sadmch_nodf)=sadmch_nans
         is(p+sadmch_tmsg)=0
         CALL sadmch_spmsg(p,'timeout')
         CALL remnode(p,'termimating node',sadmch_term,stepfl)
        ENDIF
       ENDIF
       p=is(p+sadmch_next)
       GOTO 10
11     CONTINUE
C//END
       RETURN
       END
