CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE fudge_mos(d,albe)
* copy UHF MO file (alpha or beta) to 'mos'
* V 1.0 - BAH 06052000
      INCLUDE 'defs.h'
      CHARACTER*(*) d,albe
* local
      CHARACTER*255 b1
      INTEGER lui,luo,irc,ld,la
      CHARACTER*255 dd,ab
*
* need the following statements because g77 does not like concatentaion of
* characters with indefinite length
*
      CALL clean(dd)
      CALL slen(d,ld)
      dd(1:ld)=d(1:ld)
      CALL clean(ab)
      CALL slen(albe,la)
      ab(1:la)=albe(1:la)

      WRITE (iosl,*) 'fudge_mos: copying ',albe
      lui=1
      luo=2
      OPEN (UNIT=lui,FILE=dd(1:ld)//'/'//ab(1:la),STATUS='OLD',
     * IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (iosl,*) 'fudge_mos: cannot open file ',
     * dd(1:ld)//'/'//ab(1:la)
       RETURN
      ENDIF
      OPEN (UNIT=luo,FILE=dd(1:ld)//'/mos',STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (iosl,*) 'fudge_mos: cannot open file ',dd(1:ld)//'/mos'
       RETURN
      ENDIF
1     READ (lui,'(A)',END=999) b1
* $uhfmo_alpha    scfconv=6   format(4d20.14)
      IF (index(b1,'$uhfmo').ne.0) b1(1:12)='$scfmo      '
      WRITE (luo,'(A)') b1
      GOTO 1
999   CONTINUE
      CLOSE (UNIT=lui)
      CLOSE (UNIT=luo)
      RETURN
      END

      SUBROUTINE fudge_control(tag,d)
* set $closed shells section in <control> to alpha or beta occupation,
* dpending on tag
* V 1.0 - BAH 06052000
      INCLUDE 'defs.h'
      CHARACTER*(*) tag,d
* local
      INTEGER mxr,ld
      PARAMETER (mxr=20)
      CHARACTER*255 b1,recocc(mxr)
      INTEGER lui,luo,irc,nrec,xeq,zwei,i
      CHARACTER*255 dd

      CALL clean(dd)
      CALL slen(d,ld)
      dd(1:ld)=d(1:ld)

      WRITE (iosl,*) 'fudge_control: ',tag

* copy control file to control.bu
      zwei=2
      nrec=0

      irc=xeq('cp '//dd(1:ld)//'/control '//dd(1:ld)//'/control.bu')
      IF (irc.NE.0) THEN
       WRITE (iosl,*) 'fudge_control: difficulties copying file control'
       WRITE (iosl,*) 'fudge_control: RC=',irc
       RETURN
      ENDIF

      lui=1
      luo=2
      OPEN (UNIT=lui,FILE=dd(1:ld)//'/control.bu',STATUS='OLD',
     * IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (iosl,*) 'fudge_control: cannot open file ',
     * dd(1:ld)//'/control.bu'
       WRITE (iosl,*) 'fudge_control: RC=',irc
       RETURN
      ENDIF
      OPEN (UNIT=luo,FILE=dd(1:ld)//'/control',STATUS='UNKNOWN',
     * IOSTAT=irc)
      IF (irc.NE.0) THEN
       WRITE (iosl,*) 'fudge_control: cannot open file ',
     *  dd(1:ld)//'/control'
       WRITE (iosl,*) 'fudge_control: RC=',irc
       RETURN
      ENDIF
****************************************************
CK Begin LOOP
****************************************************

1     READ (lui,'(A)',END=999) b1
5	continue

* Read and write back $alpha shells or $beta shells

      IF (index(b1,tag).ne.0) THEN
        WRITE (luo,'(A)') b1
        WRITE (iosl,'(A)') b1(1:70)
 3        READ (lui,'(A)',END=999) b1
          IF (b1(1:1).EQ.'$') GOTO 2
          WRITE (luo,'(A)') b1
          DO i=1,255
           IF (b1(i:i+1).EQ.'( ') WRITE (b1(i+2:i+2),'(I1)') zwei
          ENDDO
          nrec=nrec+1
          recocc(nrec)=b1
          WRITE (iosl,'(A)') b1(1:70)
        GOTO 3
 2      CONTINUE
      ENDIF

* copy alpha or beta occupations to $closed shell block

cMR skip closed shell section
      IF (index(b1,'$closed shells').ne.0) THEN
 4       READ (lui,'(A)',END=999) b1
         IF (b1(1:1).NE.'$') GOTO 4
	 goto 5
      endif

      IF (index(b1,'$scfmo').ne.0) THEN
	goto 1
      endif

cMR write Closed Shell section and finally $end
      IF (index(b1,'$end').ne.0) THEN
       WRITE (luo,'(A)') "$scfmo    file=mos"
       WRITE (luo,'(A)') "$closed shells"
       DO i=1,nrec
        WRITE (luo,'(A)') recocc(i)
       ENDDO
      ENDIF
cMR
      WRITE (luo,'(A)') b1
      GOTO 1

999   CONTINUE
      CLOSE (UNIT=lui)
      CLOSE (UNIT=luo)
      RETURN
      END
