CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getdip(dip,name)
* read dipole moment from file <control>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i
      REAL*8 dip(3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,3
       dip(i)=0.0d0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1)(1:7).EQ.'$dipole') THEN
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       dip(1)=getreal(item(2),ist,ien)
       CALL split(rec,item,mxitem)
       dip(2)=getreal(item(4),ist,ien)
       CALL split(rec,item,mxitem)
       dip(3)=getreal(item(6),ist,ien)
       GOTO 99
      ENDIF
      GOTO 90
99    CONTINUE
      CLOSE (UNIT=lu)
      CALL prmat(iosl,dip,1,3,'getdip: dipole')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdaldip(dip,name)
* read dipole moment from file <dalton.out>
* in case of DALTON Coupled Cluster (or MP2) calculations 
* written by J. Neugebauer, Uni Erlangen, 2002.
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i
      REAL*8 dip(3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,3
       dip(i)=0.0d0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF (index(rec,'Total Molecular Dipole Moment').ne.0) THEN
        DO i=1,5
          READ (lu,'(A)',END=99) rec
        END DO
        CALL split(rec,item,mxitem)
        ist=1
        dip(1)=getreal(item(2),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        dip(2)=getreal(item(2),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        dip(3)=getreal(item(2),ist,ien)
        GOTO 99
      ENDIF
      GOTO 90
99    CONTINUE
      CLOSE (UNIT=lu)
      CALL prmat(iosl,dip,1,3,'gdaldip: dipole')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdaldipscf(dip,name)
* read dipole moment from file <dalton.out>
* in case of DALTON SCF/MCSCF calculations 
* written by J. Neugebauer, Uni Erlangen, 2002.
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i
      REAL*8 dip(3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,3
       dip(i)=0.0d0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF (index(rec,'Dipole moment components').ne.0) THEN
        DO i=1,5
          READ (lu,'(A)',END=99) rec
        END DO
        CALL split(rec,item,mxitem)
        ist=1
        dip(1)=getreal(item(2),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        dip(2)=getreal(item(2),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        dip(3)=getreal(item(2),ist,ien)
        GOTO 99
      ENDIF
      GOTO 90
99    CONTINUE
      CLOSE (UNIT=lu)
      CALL prmat(iosl,dip,1,3,'gdaldip: dipole')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE getdipmp2(dip,name)
* read dipole moment from file <control>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i
      REAL*8 dip(3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,3
       dip(i)=0.0d0
      ENDDO
      lu=1
      write(iosl,*) 'getdipmp2: reading mp2 dipole moments'
      write(iosl,*) '           from ',name(1:80)
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF(index(rec,'calculation of the MP2 dipole moment').eq.0) goto 90
95    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1)(1:1).EQ.'x') THEN
       ist=1
       dip(1)=getreal(item(6),ist,ien)
       write(iosl,*) 'dip(1) = ',dip(1)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       dip(2)=getreal(item(6),ist,ien)
       write(iosl,*) 'dip(2) = ',dip(2)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       dip(3)=getreal(item(6),ist,ien)
       write(iosl,*) 'dip(3) = ',dip(3)
       GOTO 99
      ENDIF
      GOTO 95
99    CONTINUE
      CLOSE (UNIT=lu)
      CALL prmat(iosl,dip,1,3,'getdipmp2: dipole')
      CALL flush(iosl)
      RETURN
      END
