CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getgrad(nat,escf,grad,name)
* read SCF energy and gradient from file <name>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'cycle') GOTO 91
      GOTO 90
91    CONTINUE
      ist=1
      escf=getreal(item(7),ist,ien)
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
      ENDDO
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(1),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CALL prmat(iosl,escf,1,1,'getgrad: SCF energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalgrad(nat,escf,grad,name)
*
* read CCS/CCSD/CC2 energy and gradient from file <name>
* in case of DALTON Coupled Cluster (or MP2) calculations
* 
* written by J. Neugebauer, Uni Erlangen, 2002.
* 
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF(mode.eq.23.and.(index(rec,'Final    HF energy:').ne.0)) goto 91
      IF (item(1).EQ.'Total'.and.item(3).eq.'energy:'.and.
     & (item(2).eq.'CC2'.or.item(2).eq.'CCSD'.or.
     & (item(2).eq.'MP2'.and.mode.eq.21))) GOTO 91
      GOTO 90
91    CONTINUE
      ist=1
      escf=getreal(item(4),ist,ien)
92    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Molecular gradient').ne.0) GOTO 93
      GOTO 92
93    CONTINUE
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(4),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CLOSE(lu)
      CALL prmat(iosl,escf,1,1,'getgrad: Total energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END
 
      SUBROUTINE gdalgradscf(nat,escf,grad,name)
*
* read SCF energy and gradient from file <name>
* in case of DALTON SCF/MCSCF calculations
* 
* written by J. Neugebauer, Uni Erlangen, 2002.
* 
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF(mode.eq.25) then
        IF (index(rec,'Final MCSCF energy:').ne.0) then
          read(rec(25:),*) escf
          goto 91
        END IF
      ELSE
        IF (index(rec,'Final    HF energy:').ne.0) then
          read(rec(25:),*) escf
          goto 91
        END IF
      END IF
      GOTO 90
91    CONTINUE
      ist=1
92    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Molecular gradient').ne.0) GOTO 93
      GOTO 92
93    CONTINUE
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(4),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CLOSE(lu)
      CALL prmat(iosl,escf,1,1,'getgrad: Total energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END
