CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getpol(pol,name)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
* read polarizabilities from file <name>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,iind,isvers
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       DO jomeg=1,ipol
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
20    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      if(item(3).eq.'TURBOMOLE') then
        iind=index(item(4),'V5-')
        if(iind.ne.0) then
          read(item(4)(iind+3:iind+3),'(i1)') isvers 
          write(iosl,'(1x,a,i1)') 'found escf Version V5-',isvers
          if(isvers.lt.6) then
            goto 90
          else 
            goto 70
          end if
        else if(item(4).EQ.'working') then
          write(iosl,*) 'found working version'
          goto 70
        else
          call errex('getpol not prepared for this escf Version')
        end if
      end if
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      GOTO 20
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Electronic dipole').eq.0) GOTO 70
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'xx') THEN
       jomeg=jomeg+1
       ist=1
       pol(1,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(4,jomeg)=getreal(item(2),ist,ien)
       ist=1
       pol(7,jomeg)=getreal(item(4),ist,ien)
       ist=1
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       pol(6,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(2,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(3,jomeg)=getreal(item(2),ist,ien)
       ist=1
       pol(8,jomeg)=getreal(item(4),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(5,jomeg)=getreal(item(2),ist,ien)
       CALL prmat(iosl,pol(1,jomeg),1,8,'getpol: polarizability')
      ENDIF
      GOTO 70
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'XX' .AND. item(2).EQ.'=') THEN
       jomeg=jomeg+1
       ist=1
       pol(1,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(2,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(3,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(4,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(5,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(6,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(7,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(8,jomeg)=getreal(item(3),ist,ien)
       CALL prmat(iosl,pol(1,jomeg),1,8,'getpol: polarizability')
      ENDIF
      GOTO 90
99    CONTINUE
      IF (jomeg.NE.ipol) THEN
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       WRITE (iosl,*) ' getpol| error while reading pols. from ',name
       WRITE (iosl,*) '       | No. of pol. sets expected: ',ipol
       WRITE (iosl,*) '       | No. of pol. sets found:    ',jomeg
       WRITE (iosl,*) '       | Check $TMPDIR/pol.out.(XX) for details'
       WRITE (iosl,*) '       | (maybe escf did not converge)'
       CALL errex('jomeg=/=ipol in getpol')
      ENDIF
      CALL prmat(iosl,pol,ipol,8,'getpol: polarizability')
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalpol(pol,name)
* read polarizabilities from file <name>
* in case of DALTON Coupled Cluster calculations
* written by J. Neugebauer, Uni Erlangen, 2002
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'A operator                  B oper').eq.0) GOTO 70
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      do j=1,9
       if(j.eq.4.or.j.eq.7.or.j.eq.8) then
        do i=1,ipol+1
         READ (lu,'(A)',END=99) rec
        end do
        goto 80
       end if
       do i=1,ipol
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        jj=j
        if(j.eq.5.or.j.eq.6) jj=jj-1
        if(j.eq.9) jj=6
        if(i.gt.1) then
         pol(jj,i)=getreal(item(3),ist,ien)
        else
         pol(jj,i)=getreal(item(7),ist,ien)
        end if
       end do
       READ (lu,'(A)',END=99) rec
80    CONTINUE
      end do
99    CONTINUE
      CLOSE(lu)
      CALL prmat(iosl,pol,ipol,8,'getpol: polarizability')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalpolscf(pol,name)
* read polarizabilities from file <name>
* in case of DALTON SCF/MCSCF calculations
* written by J. Neugebauer, Uni Erlangen, 2002
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
      if(iomeg.eq.0) then
        goto 70
      else
        goto 90
      end if
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Static polarizabilities (au)').eq.0) GOTO 70
      do j=1,5
        READ (lu,'(A)',END=99) rec
      end do
      READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(1,1)=getreal(item(2),ist,ien)
      ist=1
      pol(2,1)=getreal(item(3),ist,ien)
      ist=1
      pol(3,1)=getreal(item(4),ist,ien)
      READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(4,1)=getreal(item(3),ist,ien)
      ist=1
      pol(5,1)=getreal(item(4),ist,ien)
      READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(6,1)=getreal(item(4),ist,ien)
80    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Mean value:').eq.0) GOTO 80
      CALL split(rec,item,mxitem)
      ist=1
      pol(7,1)=getreal(item(3),ist,ien)
      ist=1
      pol(8,1)=getreal(item(5),ist,ien)
      goto 99
90    do i=1,iomeg
91      READ (lu,'(A)',END=99) rec
        IF(index(rec,'Polarizability tensor for freq').eq.0) GOTO 91
        do j=1,4
          READ (lu,'(A)',END=99) rec
        end do
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(1,i)=getreal(item(2),ist,ien)
        ist=1
        pol(2,i)=getreal(item(3),ist,ien)
        ist=1
        pol(3,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(4,i)=getreal(item(3),ist,ien)
        ist=1
        pol(5,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(6,i)=getreal(item(4),ist,ien)
      end do
99    CONTINUE
      CLOSE(lu)
**    CALL prmat(iosl,pol,ipol,8,'getpol: polarizability')
      CALL flush(iosl)
      RETURN
      END


