CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      DOUBLE PRECISION FUNCTION getreal(x,ist,end)
*******************************************************************************
* $Log: getreal.r,v $
* Revision 1.4  2002/02/12 12:50:54  nbauer
* GNU GPL included
*
* Revision 1.3  2002/01/30 19:44:57  nbauer
* MCSCF calculations possible
*
* interpret the next nonblank string as real
* set result to zero if the field is not numeric
* BAH, 30.01.98
*******************************************************************************
      IMPLICIT none
      CHARACTER*(*) x
      INTEGER i,l,start,end,idot,ist
      REAL*8 result
      LOGICAL numric
      CHARACTER*255 buf
      result=0.D0
      l=LEN(x)
      idot=0

* skip blanks
      DO i=ist,l
       IF (x(i:i).NE.' ') GOTO 10
      ENDDO
      GOTO 90
10    start=i

* numeric, +, -
      IF (numric(x(i:i)) .OR. x(i:i).EQ.'-' .OR. x(i:i).EQ.'+') GOTO 11
* check for leading decimal point; at least one numeric character must follow
      idot=1
      i=i+1
      IF (x(i-1:i-1).EQ.'.' .AND. numric(x(i:i))) GOTO 11
* the string cannot be interpreted as real number
      CALL nbllen(x,l)
      WRITE (*,*) '[getreal] non-numeric field <',x(ist:l),'>'
      GOTO 90

* mantissa
11    i=i+1
      IF (numric(x(i:i))) GOTO 11
12    end=i-1
      IF (x(i:i).EQ.'.') THEN
       if (idot.EQ.1) GOTO 89
       idot=1
       GOTO 11
      ENDIF
      IF (x(i:i).EQ.'D' .OR. x(i:i).EQ.'d') GOTO 13
      IF (x(i:i).EQ.'E' .OR. x(i:i).EQ.'e') GOTO 13
      GOTO 89

* exponent
13    i=i+1
      IF (numric(x(i:i)) .OR. x(i:i).EQ.'-' .OR. x(i:i).EQ.'+') GOTO 14
      GOTO 89
14    i=i+1
      IF (numric(x(i:i))) GOTO 14
      end=i-1

* read the real on the largest field that can be interpreted as real
89    CALL clean(buf)
      buf=x(start:end)
      READ (buf,'(G25.10)') result

* return the result
90    getreal=result
C@    WRITE (idbg,*) '[getreal] <',x(ist:l),'>'
C@    WRITE (idbg,*) '[getreal] start=',start,' end=',end,' result=',
C@   * result
      RETURN
      END
      SUBROUTINE NBLLEN(X,N)
      CHARACTER*(*) X
      l=LEN(x)
      DO 1 i=l,1,-1
      IF (X(i:i).NE.' ') GOTO 2
1     CONTINUE
      i=0
2     n=i
      RETURN
      END
