CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getres(p,g,dip,pol,gra,stepfl,vmach)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
*
* get results for node i
* dictionary of nodefl:
*                        -2          waiting to be spawned
*                        -1          terminated
*                         0          not used
*                         1          working
*                         2          waiting for work
      INTEGER p
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INCLUDE 'sadmch.h'
      INTEGER stepfl(*)
      INTEGER ibuf,m,info,icmp,iaus,now,nse,tid,ia,ib,i,j,jomeg
      INTEGER*4 nit
      CHARACTER*24 date
      CHARACTER*40 msg,name
      REAL*8 g(nvar)
      REAL*8 dip(3,naus,nvar)
      REAL*8 pol(mxomeg,8,naus,nvar)
      REAL*8 gra(nvar,naus,nvar)
      REAL*8 e,d(3),po(8,mxomeg)
      REAL*8 cpu,wall,gcpu,gwall
      REAL*8 gsum,se,vmach(*)
C#    INTEGER st(MPI_STATUS_SIZE)
C#    INTEGER w
C#    LOGICAL flag
C#    DATA w /MPI_COMM_WORLD/

      tid=is(p+sadmch_tid)
C//SKIPC#2
      CALL PVMFTRECV(tid,0,1,0,ibuf)
      IF (ibuf.EQ.0) RETURN
C#    CALL MPI_IPROBE(tid,fsys_restag,w,flag,st,info)
C#    CALL mpierr('MPI_PROBE','getres',info)
C#    IF (.NOT.flag) RETURN

      is(p+sadmch_nodf)=sadmch_chk
      CALL sadmch_gname(p,name)

C#     CALL MPI_RECV(nit,1,MPI_INTEGER,tid,fsys_restag,w,st,info)
C#     CALL mpierr('MPI_RECV icall','getres',info)
C#     CALL MPI_RECV(cpu,1,MPI_DOUBLE_PRECISION,tid,801,w,st,info)
C#     CALL mpierr('MPI_RECV cpu','getres',info)
C#     CALL MPI_RECV(wall,1,MPI_DOUBLE_PRECISION,tid,802,w,st,info)
C#     CALL mpierr('MPI_RECV wall','getres',info)
C#     CALL MPI_RECV(gcpu,1,MPI_DOUBLE_PRECISION,tid,803,w,st,info)
C#     CALL mpierr('MPI_RECV gcpu','getres',info)
C#     CALL MPI_RECV(gwall,1,MPI_DOUBLE_PRECISION,tid,804,w,st,info)
C#     CALL mpierr('MPI_RECV gwall','getres',info)
C#     CALL MPI_RECV(e,1,MPI_DOUBLE_PRECISION,tid,805,w,st,info)
C#     CALL mpierr('MPI_RECV e','getres',info)
C#     CALL MPI_RECV(d,3,MPI_DOUBLE_PRECISION,tid,806,w,st,info)
C#     CALL mpierr('MPI_RECV d','getres',info)
C#     CALL MPI_RECV(g,nvar,MPI_DOUBLE_PRECISION,tid,807,w,st,info)
C#     CALL mpierr('MPI_RECV g','getres',info)
C#     IF (inputpol.GT.0) THEN
C#     CALL MPI_RECV(po,ipol*8,MPI_DOUBLE_PRECISION,tid,808,w,st,info)
C#     CALL mpierr('MPI_RECV po','getres',info)
C#     ENDIF

C//SKIPC#
      CALL PVMFUNPACK(INTEGER4,nit,1,1,info)
      CALL PVMFUNPACK(REAL8,cpu,1,1,info)
      CALL PVMFUNPACK(REAL8,wall,1,1,info)
      CALL PVMFUNPACK(REAL8,gcpu,1,1,info)
      CALL PVMFUNPACK(REAL8,gwall,1,1,info)
      CALL PVMFUNPACK(REAL8,e,1,1,info)
      CALL PVMFUNPACK(REAL8,d,3,1,info)
      CALL PVMFUNPACK(REAL8,g,nvar,1,info)
      IF (inputpol.GT.0) CALL PVMFUNPACK(REAL8,po,8*ipol,1,info)
C//END

C@    WRITE (jtape,'(4D18.8)') e
C@    WRITE (jtape,*) ' '
C@    WRITE (jtape,'(4D18.8)') (d(j),j=1,3)
C@    WRITE (jtape,*) ' '
C@    WRITE (jtape,'(4D18.8)') (g(j),j=1,nvar)
C@    WRITE (jtape,*) ' '
C@    WRITE (jtape,'(4D18.8)') (po(j),j=1,8*ipol)
C@    WRITE (jtape,*) ' '
            
      gsum=0.0d0
      DO j=1,nvar
         gsum=gsum+g(j)**2
      ENDDO
      se=wall+gwall
      nse=se
      CALL secs(now)
      IF (is(p+sadmch_last).GT.0) THEN
       i=is(p+sadmch_time)+is(p+sadmch_last)
       WRITE (idbg,*) 'getres: now ',now,
     *                ' node ',is(p+sadmch_numb),
     *                ' expected ',i,
     *                ' used     ',nse,
     *                ' on ',name(1:8),'[D=',i-now,']'
      ENDIF
      is(p+sadmch_last)=now-is(p+sadmch_time)
      is(p+sadmch_time)=0
      ia=is(p+sadmch_stpa)
      ib=is(p+sadmch_stpb)
       
* the energies are not used beyond this point, and in particular
* not written to the restart file

      IF (gsum.lt.1.d-16.or.gsum.GT.1.OR.e.GE.0.D0) THEN
       IF (e.GE.0.D0) THEN
        WRITE (msg,'(A20,D20.10)') ' invalid energy:',e
        CALL remnode(p,msg,sadmch_fai1,stepfl)
       ELSE
        WRITE (msg,'(A20,D20.10)') ' invalid gsum:',gsum
        CALL remnode(p,msg,sadmch_fai2,stepfl)
       ENDIF
** shut down the process
       CALL remnode(p,'wrong results',sadmch_term,stepfl)
       RETURN
      ELSE
       CALL fdate(date)
       WRITE (jtape,109)
     .    date,'<- ',tid,name(1:10),ia,
     .    nit,cpu,wall,gcpu,gwall
109      FORMAT(A,A,I10,' ',A,' return  step ',I3/,
     .    (30X,I2,'i',F10.1,'c',F10.1,'w',F10.1,'c',F10.1,'w'))
       CALL flush(jtape)
       CALL sadmch_fname(pvmmch,name)
       IF (cmch.GT.0) is(cmch+sadmch_usag)=is(cmch+sadmch_usag)+1
      ENDIF

      stepfl(ia)=1
      iaus=MOD(ia,naus)
      IF (iaus.EQ.0) iaus=naus
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      m=ia/naus
      if(mod(ia,naus).ne.0) m=m+1
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO icmp=1,3
       dip(icmp,iaus,m)=d(icmp)
      ENDDO
      DO jomeg=1,ipol
       DO icmp=1,8
        pol(jomeg,icmp,iaus,m)=po(icmp,jomeg)
       ENDDO
      ENDDO
      DO icmp=1,nvar
       gra(icmp,iaus,m)=g(icmp)
      ENDDO

      is(p+sadmch_nodf)=sadmch_rdy
      is(p+sadmch_tpid)=0
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      CALL wrestart(vmach,dip,pol,gra,stepfl)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      CALL sadmch_dmp(idbg,p)

** stop host if a shutdown command has been received

      IF (is(p+sadmch_cmd).EQ.sadmch_shut)
     * CALL remnode(p,'shutdown cmd',0,stepfl)

C//SKIPC#1
      CALL updvm(updopt)

      RETURN
      END
