CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE islave
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INTEGER l,ibuf,info,mbuf,ierr,irc,xeq,now,w,ns,lfilen
      INTEGER intgr,iclean,icleanl,idalmw
C#    INTEGER st(MPI_STATUS_SIZE)
C#    CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiname
      INTEGER*4 iready,iwhat,kvers
      logical snffast
      CHARACTER*255 b1,b2,filename
      character*80 dalmw
      CHARACTER*40 mynode,pnode
      INCLUDE 'VERSION.h'
**
** slave processes
**
      ns=mxwrk

* receive tempdir, jobdir, parent node name, current node name from master

C#      CALL MPI_GET_PROCESSOR_NAME(mpiname,l,info)
C#      CALL mpierr('MPI_GET_PROCESSOR_NAME','islave',info)
C#      CALL clean(mynode)
C#      mynode=mpiname(1:l)
        WRITE (*,*) 'islave: mynode=',mynode
        WRITE (iosl,*) 'islave: mynode=',mynode

        CALL pgetstr('islave: logdir',logdir,tid0,255,401,info)
        WRITE (iosl,*) 'islave: logdir=',logdir
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        CALL slen(logdir,ll)
        CALL secs(now)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        CALL augnum(filename,logdir(1:ll)//'dclog.',now)
        CALL slen(logdir,ll)
        OPEN (unit=iosl,file=filename,STATUS='UNKNOWN')

        WRITE (iosl,*) '>>> snfdc slave log file for tid ',mytid
        WRITE (iosl,*) version
        CALL pgetstr('islave: turbodir',turbodir,tid0,255,402,info)
        CALL pgetstr('islave: arpath',arpath,tid0,255,403,info)
        CALL pgetstr('islave: masterid',masterid,tid0,255,404,info)
        CALL pgetstr('islave: tmpnode',b1,tid0,255,405,info)
        CALL pgetstr('islave: mydir',mydir,tid0,255,406,info)
        CALL pgetstr('islave: pnode',pnode,tid0,40,407,info)
        WRITE (iosl,*) 'islave: turbodir=',turbodir
        CALL flush(iosl)
C#      CALL pputstr('islave: mynode',mynode,tid0,40,408,info)
C//SKIPC#1
        CALL pgetstr('islave: mynode',mynode,tid0,40,408,info)
        CALL slen(b1,lt)
        CALL slen(mydir,lm)
        CALL slen(arpath,lar)
        CALL slen(turbodir,lb)
        CALL slen(masterid,li)
C#      now=10*now+mytid

        CALL memmgr(1024 ,'memdbg',0,0,iosl)
        CALL memmgr(memini,'init',is,1,ns)
        CALL clean(b2)
        CALL fdate(b2)
        WRITE (iosl,*) b2(1:40)
        CALL flush(iosl)
        WRITE (iosl,*) 'TMPDIR=',b1(1:lt)
        WRITE (iosl,*) 'LOGDIR=',logdir(1:ll)
        WRITE (iosl,*) turbodir(1:10)
CBAH the brain-damaged pgf90 cannot write a string of length 0 without
CBAH crashing the program ...
        IF (lb.GT.0) WRITE (iosl,*) 'TURBODIR=',turbodir(1:lb)
        WRITE (iosl,*) 'MYDIR =',mydir(1:lm)
        WRITE (iosl,*) 'MYNODE=',mynode
        WRITE (iosl,*) 'PNODE =',pnode
        CALL augnum(tempdir,b1(1:lt)//'/TMP',now)
        CALL slen(tempdir,lt)
        WRITE (iosl,*) 'PE0 TID=',tid0
        CALL flush(iosl)
        info=xeq('mkdir '//tempdir(1:lt))
        info=0

        WRITE (iosl,*) 'islave: waiting for <control>'
        CALL flush(iosl)
C&      WRITE (iosl,*) 'get control from ',mynode
C&      CALL getfile('control',mynode,pnode,info)
C&      WRITE (iosl,*) 'return form getfile, info=',info
C//SKIPC&1
        CALL gfile('control',tid0,info)

CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        CALL rcontrol(tempdir(1:lt)//'/control',natoms,mode,inputdip,
     *  inputpol,cstep,jscfc,isuhf,iomeg,mxomeg,omeg,naus,iclean,
     *  icleanl,dalmw,idalmw,snffast,idbg)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        ipol=0
        IF (inputpol.EQ.1) ipol=1
        IF (inputpol.EQ.2) ipol=iomeg
cMRCK
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       if (mode.ne.1.and.mode.ne.4.and.mode.ne.5.and.mode.ne.6) then
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         okok=11111
          IF (isuhf.GT.0) okok=111111
       else
         okok=1111
          IF (isuhf.GT.0) okok=11111
       end if
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       IF (mode.eq.2.or.mode.eq.3.or.mode.eq.7.or.mode.eq.8) then
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C&       CALL getfile('auxbasis',mynode,pnode,info)
C//SKIPC&1
         CALL gfile('auxbasis',tid0,info)
       ENDIF
cMRCK
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       IF (mode.ge.20.and.mode.le.25) THEN
C&       CALL getfile('molecule.dal',mynode,pnode,info)
C//SKIPC&1
         CALL gfile('molecule.dal',tid0,info)
       ENDIF
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

C&      CALL getfile('basis',mynode,pnode,info)
C//SKIPC&1
        CALL gfile('basis',tid0,info)
        IF (isuhf.EQ.0) THEN
C&       CALL getfile('mos',mynode,pnode,info)
C//SKIPC&1
         CALL gfile('mos',tid0,info)
        ELSE
C&       CALL getfile('alpha',mynode,pnode,info)
C&       CALL getfile('beta',mynode,pnode,info)
C//SKIPC&2
         CALL gfile('alpha',tid0,info)
         CALL gfile('beta',tid0,info)
        ENDIF
C&      CALL getfile('coord',mynode,pnode,info)
C//SKIPC&1
        CALL gfile('coord',tid0,info)
        write(iosl,*) 'islave: coord copied, info=',info
        CALL flush(iosl)
        IF (info.EQ.okok) THEN
         IF (isuhf.EQ.0) THEN
          CALL clean(b1)
          b1=tempdir(1:lt)//'/mos'
          CALL llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
         ELSE
          CALL clean(b1)
          b1=tempdir(1:lt)//'/alpha'
          CALL llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
          CALL clean(b1)
          b1=tempdir(1:lt)//'/beta'
          CALL llen(b1,l)
          irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
         ENDIF
         CALL clean(b1)
         b1=tempdir(1:lt)//'/coord'
         CALL llen(b1,l)
         irc=xeq('mv '//b1(1:l)//' '//b1(1:l)//'.ori')
        ENDIF
        WRITE (iosl,*) '>>> input files copied, results is ',info
        CALL flush(iosl)
        iready=info
        WRITE (b1,'(I5)') ivers
C@      CALL mnotify(9,mytid,iready,b1,5)

C#      w=MPI_COMM_WORLD
C:      CALL MPI_SSEND(iready,1,MPI_INTEGER,tid0,407,w,info)
C//SKIPC:1
C#      CALL MPI_SEND(iready,1,MPI_INTEGER,tid0,407,w,info)
C#      CALL mpierr('MPI_(S)SEND iready','islave',info)
C:      CALL MPI_SSEND(ivers,1,MPI_INTEGER,tid0,408,w,info)
C//SKIPC:1
C#      CALL MPI_SEND(ivers,1,MPI_INTEGER,tid0,408,w,info)
C#      CALL mpierr('MPI_(S)SEND ivers','islave',info)
C#      IF (iready.NE.okok) THEN
C#       WRITE (iosl,*) '>>> calling termcomm: iready=',iready
C#       CALL flush(iosl)
C#       CALL termcomm('islave: not ready')
C#      ENDIF

C#52    CALL MPI_RECV(iwhat,1,MPI_INTEGER,tid0,409,w,st,info)
C#      CALL mpierr('MPI_RECV iwhat','islave',info)
C#      IF (iwhat.EQ.1) CALL cslave
C#      IF (iwhat.GE.0) GOTO 52

C//SKIPC#
        CALL PVMFINITSEND(PVMDATADEFAULT,MBUF)
        CALL PVMFPACK(INTEGER4, iready, 1, 1, INFO )
        IF (info.NE.0) CALL pvmfperror('pack iready',info)
        kvers=ivers
        CALL PVMFPACK(INTEGER4, kvers, 1, 1, INFO )
        IF (info.NE.0) CALL pvmfperror('pack ivers',info)
        CALL PVMFSEND( tid0, 0, INFO )
        IF (info.NE.0) CALL pvmfperror('send iready',info)
        IF (iready.NE.okok) THEN
         WRITE (iosl,*) '>>> calling termcomm: iready=',iready
         CALL flush(iosl)
         CALL termcomm('islave: not ready')
        ENDIF

* receive command

 42     CALL PVMFRECV(tid0,0,ibuf)
        CALL PVMFUNPACK(INTEGER4,iwhat,1,1,info)
        WRITE (iosl,*) '>>> iwhat =',iwhat
        CALL flush(iosl)
        WRITE (iosl,*) 'islave: ',tempdir(1:lt)
        if(iwhat.eq.1) call cslave
        if(iwhat.gt.-1) goto 42
C//END
 99   CONTINUE
      WRITE (iosl,*) '>>> finishing'
      CALL flush(iosl)
C@    info=xeq('rm -rf '//tempdir(1:lt))
      WRITE (iosl,*) 'slave tid ',mytid,' stopping.'
      CLOSE (UNIT=iosl)
      if(icleanl.eq.1) then
        CALL slen(filename,lfilen)
        info=xeq('rm '//filename(1:lfilen))
      end if
      RETURN
      END
