CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      PROGRAM snfdc

* data collector for the program snf, a program
* to calculate infrared and Raman spectra by means of numerical
* derivatives calculated by the TURBOMOLE program
*

      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'  
      INTEGER ierr,ns,ipe
      INCLUDE 'VERSION.h'

      inrec=0
      iin=0
      ierr=0
      iomeg=0
      iscfc=8
      naus=2
      pmch=0
      isuhf=0
      pvmmch=0
      ns=mxwrk

      CALL iniparam                          ! initialize program parameters
      CALL inictok                           ! initialize token queue
      CALL inicomm(mytid,tid0,ipe)           ! initialize communication
      IF (ipe.EQ.0) THEN                     ! th master process
       iosl=idbg
       CALL memmgr(1024 ,'memdbg',0,0,iosl)
       CALL memmgr(memini,'init',is,1,ns)
       CALL imaster                          ! initialize master
       CALL nodeini                          ! initialize slave processes
       CALL rdparm                           ! read input
C//SKIPC#1
       CALL rduse                            ! read PVM configuration options
       CALL tmini                            ! initialize TURBOMOLE parameters
       CALL master                           ! run master scheduler
       CALL shutdown                         ! shutdown virtual computer
      ELSE
       iosl=43
       CALL islave                           ! run slave process
      ENDIF
      CALL termcomm                          ! terminate program
* program will not return
      STOP 'miracle in main program'
      END
