CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE master
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'param.h'  
      INCLUDE 'objects.h'
      INCLUDE 'sadmch.h'

      INTEGER i
      INTEGER p3,ize,ipe,iprc,info
      INTEGER pdipder,pddip,puc,peig,pamass,ph,pdip,ppol,pgra,pstepfl
      INTEGER pvmach
      CHARACTER*8 dash
      DATA dash /'--------'/
      
* 
* allocate storage for dipole, polarizability and gradient arrays
*
      CALL memmgr(memgdw,'dipol   ',s8,pdip,3*naus*nvar)
      CALL memmgr(memgdw,'polar   ',s8,ppol,8*naus*nvar*mxomeg)
      CALL memmgr(memgdw,'grad    ',s8,pgra,3*natoms*naus*nvar)
      CALL memmgr(memget,'istepfl ',is,pstepfl,nstept)
      CALL memmgr(memgdw,'nvmach  ',s8,pvmach,nstept)
      
      DO i=1,nstept
       READ (dash,'(A8)') s8(pvmach+i-1)
       is(pstepfl+i-1)=0
      ENDDO

*
* in case of MPI, we have to set up all slaves for communication.
* otherwise, we get into trouble if some of the slaves are not called.
*
C#    p3=pmch
C#20  IF (p3.EQ.0) GOTO 21      
C#    CALL spawn(p3,idbg)
C#    p3=is(p3+sadmch_next)
C#    GOTO 20
C#21  CONTINUE

      CALL rrestart(s8(pvmach),s8(pdip),s8(ppol),s8(pgra),is(pstepfl),i)
      WRITE (idbg,*) ' master| <restart> read'
      IF (i.EQ.nstept) pskp=2
      IF (pskp.EQ.0) THEN
       CALL memmgr(memgdw,'g       ',s8,p3,nvar)
       CALL parstuff(s8(p3),s8(pdip),s8(ppol),s8(pgra),is(pstepfl),
     *  s8(pvmach))
       CALL memmgr(memfdw,'g       ',s8,p3,nvar)
      ENDIF

      CALL howmany(ize,ipe,iprc,is(pstepfl))

      CALL memmgr(memfdw,'dipol   ',s8,pdip,3*naus*nvar)
      CALL memmgr(memfdw,'polar   ',s8,ppol,8*naus*nvar*mxomeg)
      CALL memmgr(memfdw,'grad    ',s8,pgra,3*natoms*naus*nvar)
      CALL memmgr(memfre,'istepfl ',is,pstepfl,nstept)
      CALL flush(idbg)
      
      RETURN
      END 
