c $Id: memmgr.r,v 1.3 2002/01/30 19:44:57 nbauer Exp $
c  DELC8              nwordl=8, nlongr=1
c memory manager
c   Copyright (C) 1995, 1997, 1999 Bernd Artur Hess, hess@chemie.uni-erlangen.de
c
c   This program is free software; you can redistribute it and/or modify
c   it under the terms of the GNU General Public License as published by
c   the Free Software Foundation; either version 2 of the License, or
c   (at your option) any later version.
c
c   This program is distributed in the hope that it will be useful,
c   but WITHOUT ANY WARRANTY; without even the implied warranty of
c   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c   GNU General Public License for more details.
c
c   You should have received a copy of the GNU General Public License
c   along with this program; if not, write to the Free Software
c   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c
      subroutine memmgr(iopt,name,memory,ipin,nw)
c $Log: memmgr.r,v $
c Revision 1.3  2002/01/30 19:44:57  nbauer
c MCSCF calculations possible
c
c
c     CALL memmgr(memini,name,is,ipin,nw)
c                        initialize mmgr
c                        name: options string, a '*' plus following flags
c                              c          check off
c                              n          nofree
c                              t          trace off
c                        is  : work array
c                        ipin: first array element of scratch area
c                        nw  : length of scratch area in words
c     CALL memmgr(memdbg,name,is,ipin,nw)
c                        initialize mmgr
c                        name: not used
c                        is  : not used
c                        ipin: not used
c                        nw  : debug unit
c     CALL memmgr(memget,name,is,ipin,nw)
c                        name: variable name
c                        is  : work array
c                        ipin: (output) start of array
c                        nw  : length of array in words
c     CALL memmgr(memgdw,name,dpis,ipin,nw)
c                        name: variable name
c                        dpis: work array (indexed as double precision)
c                        ipin: (output) start of array
c                        nw  : length of array in doublewords
c     CALL memmgr(memfre,name,is,ipin,nw)
c                        name: variable name
c                        is  : work array
c                        ipin: start of array
c                        nw  : not used
c     CALL memmgr(memfdw,name,dwis,ipin,nw)
c                        name: variable name
c                        dwis: work array
c                        ipin: start of array
c                        nw  : not used
c     CALL memmgr(memrep,name,is,ipin,nw)
c                        name: used only for printout
c                        is  : work array
c                        ipin: output unit
c                        nw  : not used
c     CALL memmgr(memmax,name,is,ipin,nw)
c                        name: used only for printout
c                        is  : work array
c                        ipin: (output) size of largest available chunk
c                        nw  : not used
c     CALL memmgr(memclp,name,is,ipin,nw)
c                        name: used only for printout
c                        is  : work array
c                        ipin: adress of array
c                        nw  : new length
c     CALL memmgr(memchk,name,is,ipin,nw)
c                        name: used only for printout
c                        is  : work array
c                        ipin: output unit
c                        nw  : not used
c
      IMPLICIT none
*
      INTEGER memget,memfre,memrep,memini,memmax,memchk,
     *memclp,memgdw,memfdw,iprmck,iprmpr,iprnof,memdbg
      parameter (memget=2,memfre=4,memrep=8,memini=16,memmax=32,
     *memclp=64,memgdw=128,memfdw=256,memchk=512,memdbg=1024)
      parameter (iprmpr=1,iprmck=2,iprnof=4)
*
      integer iopt,ipin,nw,memory(*),add,atend,mxxad
      parameter (add=6,atend=2,mxxad=100)
      integer have,next,prev
      logical lpr
      character*(*) name
      character*8 aname
      integer i,k,free,alloc,need,nalloc,used,cumu,myadr,ixad
      character*2 unit
      character*10 freech
      character*8 tname
      character*60 rcsid
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape,jtp,idb,memxad
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
      data free /0/, alloc /0/, nalloc /0/, jtp /6/, idb /41/
      data freech /'**free**  '/
      data rcsid
     */'$Id: memmgr.r,v 1.3 2002/01/30 19:44:57 nbauer Exp $'/
      save
      aname='      >>'
      k=len(name)
      if (k.lt.6) then
       aname(1:k)=name(1:k)
      else
       aname(1:6)=name(1:6)
      endif
c@    WRITE (idbg,120) 'memmgr',name,iopt,ipin,nw
      lpr=mod(iprmem,2*iprmpr).ge.iprmpr
c      iprmck: check integrity of storage management
c      iprmpr: verbose
c      iprnof: do not free storage until memrep is called
      if (iopt.eq.memchk .or. mod(iprmem,2*iprmck).ge.iprmck) then
       call memck(nalloc,memory,free,alloc,iopt,name,ixad)
      endif
c
      if (iopt.eq.memget) goto 10
      if (iopt.eq.memgdw) goto 11
      if (iopt.eq.memini) goto 20
      if (iopt.eq.memrep) goto 30
      if (iopt.eq.memfre) goto 40
      if (iopt.eq.memfdw) goto 43
      if (iopt.eq.memmax) goto 50
      if (iopt.eq.memclp) goto 60
      if (iopt.eq.memdbg) goto 70
      if (iopt.eq.memchk) return
c
      write (idbg,120) 'memmgr',name,iopt,nw
120   format(a8,'| called: ',a8,1x,i3,2i10)
      call errex('memmgr| invalid memmgr option')
c-----------------------------------------------------------------------
*     allocate as double precision
c-----------------------------------------------------------------------
11    unit='DW'
      need=nlongr*nw + add
      goto 12
c-----------------------------------------------------------------------
c     allocate memory for an array of length nw words
c-----------------------------------------------------------------------
10    unit='WD'
      need=2*( (nw+1)/2 ) + add
12    continue
* always allocate even number of words in order to preserve alignment
      need = 2 * ( (need +1) / 2 )
      IF (need.LT.0)
     * CALL errex('memmgr: number of words requested is negative')
c@    CALL memdmp(jtape,memory,free,alloc)
      i=free
      prev=0
c
c      loop over memory chunks
c
1     continue
      if (i.le.0) then
       write (idbg,130) '  memmgr',name,nw
130    format(a8,'| allocation of ',a8,i10,' failed.')
       call memdmp(jtape,memory,free,alloc)
       call errex('memmgr| all chunks too small - need more memory')
      endif
      next=memory(i)
      if (memory(i+1).lt.need) then
       prev=i
       i=next
       goto 1
      endif
c      OK, chunk large enough
      have=memory(i+1)
* V 1.8 if not enough space for another allocation is left at the end, then
*       allocate all that is there
      IF (have-need .LT. add+2) need=have
* V 1.8 end
      ipin=i+add-atend
      memory(i)=alloc
      alloc=i
      nalloc=nalloc+1
      memory(i+1)=need
      if (iopt.eq.memgdw) then
       ipin=(ipin-1)/2+1
      endif
      read (aname,'(2A4)') memory(i+2),memory(i+3)
****** duplicate the array name at the end -- to faciliate consistency check
      memory(i+need-2)=memory(i+2)
      memory(i+need-1)=memory(i+3)
****** remember address in array memxad, unless there are too many allocations
      if (ixad.lt.mxxad) then
       ixad=ixad+1
       memxad(ixad)=i
      else
       do 81 k=1,ixad
        if (memxad(k).eq.0) then
         memxad(k)=i
         goto 80
        endif
81     continue
      endif
80    continue
      if (lpr)
     * write (idbg,110) 'memmgr',name,need,unit,alloc,need,ipin
110   format(a8,'| ',a,i10,1x,a2,' at',i10,' L=',i10,' array-adr =',i10)
      if (have.eq.need) then
       if (i.eq.free) then
        free = next
        return
       endif
       if (prev.gt.0) then
        memory(prev)=next
       else
        free=next
       endif
       return
      endif
      i=i+need
      memory(i)=next
      memory(i+1)=have-need
      read (freech,'(2A4)') memory(i+2),memory(i+3)
      if (prev.gt.0) then
       memory(prev)=i
      else
       free=i
      endif
      return
c-----------------------------------------------------------------------
c       initialize memory
c-----------------------------------------------------------------------
70    idb=nw
      RETURN

20    free=ipin
      jtape=jtp
      idbg=idb
      iprmem=iprmck+iprmpr
      WRITE (idbg,*) ' memmgr| (C) 1997 Bernd Artur Hess'
      WRITE (idbg,*) '       | ',rcsid
      IF (name(1:1).EQ.'*') THEN
       WRITE (idbg,*) '       | evaluating name string: ',name
       k=LEN(name)
       DO 29 i=2,k
        IF (name(i:i).EQ.'c' .OR. name(i:i).EQ.'C') iprmem=iprmem-iprmck
        IF (name(i:i).EQ.'n' .OR. name(i:i).EQ.'N') iprmem=iprmem+iprnof
        IF (name(i:i).EQ.'t' .OR. name(i:i).EQ.'T') iprmem=iprmem-iprmpr
        IF (name(i:i).EQ.'h' .OR. name(i:i).EQ.'H') THEN
         WRITE (jtape,*) ' memmgr| options:'
         WRITE (jtape,*)
     *    '       | c  :  toggle check  flag (default: on)'
         WRITE (jtape,*)
     *    '       | n  :  toggle nofree flag (default: off)'
         WRITE (jtape,*)
     *    '       | t  :  toggle trace  flag (default: on)'
        ENDIF
29     CONTINUE
      ENDIF
      IF (MOD(iprmem,2*iprmck).GE.iprmck) THEN
       WRITE (idbg,*) ' memmgr| *c : check on'
      ELSE
       WRITE (idbg,*) ' memmgr| *c : check off'
      ENDIF
      IF (MOD(iprmem,2*iprnof).GE.iprnof)
     * WRITE (idbg,*) ' memmgr| *n : nofree'
      IF (MOD(iprmem,2*iprmpr).GE.iprmpr) THEN
       WRITE (idbg,*) ' memmgr| *t : trace on'
      ELSE
       WRITE (idbg,*) ' memmgr| *t : trace off'
      ENDIF
C//SKIPC8
      nlongr=2
      nwordl=4
C8    nlongr=1
C8    nwordl=8
* align to next double word
      free = 2 * (free/2) + 1
      memory(free)=0
      memory(free+1)= nw - (free - ipin)
      ixad=0
      used=0
      cumu=0
      call memdmp(idbg,memory,free,alloc)
      if (nlongr.eq.0) then
       stop 'variable nlongr not initialized'
      endif
      return
c-----------------------------------------------------------------------
c     free memory
c-----------------------------------------------------------------------
****** deallocate doublewords
43    myadr=2*(ipin-1)+1
      unit='DW'
      goto 42
****** deallocate words
40    myadr=ipin
      unit='WD'
42    continue
c@    CALL memdmp(jtape,memory,free,alloc)
****** make sure that the memory structure is OK
      call memck(nalloc,memory,free,alloc,iopt,name,ixad)
      i=alloc
      prev=0
41    continue
c@    WRITE (idbg,401) prev,i,memory(i),memory(i+1),memory(i+2),memory(i+3)
c@401 FORMAT('  memmgr@41 ',4I10,1X,'[',2A4,']')
      if (i.le.0) goto 49
      if (i.ne.myadr-add+atend) then
       prev=i
       i=memory(i)
       goto 41
      endif
      if (name.ne.'********') then
******  compare specified name against name in memory structure
       write (tname,'(2A4)') memory(i+2),memory(i+3)
       if (tname.ne.aname) then
        write (jtape,409) aname,i
  409   format('  memmgr| memfre | ',a,' not found at address ',i10)
        write (jtape,408) tname
  408   format('        | found at specified address: ',a)
        call errex('memfre | memory structure dubious')
       endif
      endif
      have=i+memory(i+1)
      if (mod(iprmem,2*iprnof).ge.iprnof) then
       if (lpr) write (idbg,'(A8,''| '',A)') 'memmgr',
     * '*W* memfre not executed because iprnof flag is set'
       return
      endif
****** remove entry freo memxad array
      do k=1,ixad
       if (memxad(k).eq.i) memxad(k)=0
      enddo
      if (lpr) write (idbg,142) 'memmgr',
     *name,memory(i+1),unit,i
142   format(a8,'| ',a,i10,' words allocated as ',a2,' now free at',i10)
      used=used-memory(i+1)
      call memdeq(memory,alloc,prev,i)
      nalloc=nalloc-1
      memory(i)=free
      free=i
      call memgbc(memory,free,lpr)
      return
49    continue
      write (jtape,141) 'memmgr',name,ipin
141   format(a8,'| *WARNING* cannot free array ',a8,', not found at',
     *i12)
      return
c-----------------------------------------------------------------------
c     get size of largest available chunk
c-----------------------------------------------------------------------
50    continue
      i=free
      ipin=0
      have=0
51    continue
      if (i.eq.0) then
       if (lpr) write (idbg,150) 'memmgr',name,have,ipin
150    format(a8,'| ',a,' largest chunk at',i10,' [',i10,']')
       ipin=ipin-add
       ipin=ipin-10
       return
      endif
      if (memory(i+1).gt.ipin) then
       ipin=memory(i+1)
       have=i
      endif
      i=memory(i)
      goto 51
c-----------------------------------------------------------------------
c      clip allocated chunk at the end; new array length in nw
c-----------------------------------------------------------------------
60    continue
      i=alloc
      prev=0
61    if (i.eq.0) return
      if (i.ne.ipin-add+atend) then
       prev=i
       i=memory(i)
       goto 61
      endif
      need=2*( (nw+1)/2 ) + add
      have=memory(i+1)-need
      memory(i+1)=need
      memory(i+need-2)=memory(i+2)
      memory(i+need-1)=memory(i+3)
      if (lpr) write (idbg,161) 'memmgr',i,need,have
161   format(a8,'| clip   ',i12,' L=',i12,i12,i12)
      i=i+need
      memory(i+1)=have
      call memenq(memory,free,free,i)
      return
c-----------------------------------------------------------------------
c     dump memory
c-----------------------------------------------------------------------
30    continue
      write (ipin,140) 'memmgr',name
140   format(a8,'| memory allocation ',a)
      call memdmp(ipin,memory,free,alloc)
      return
      end
      subroutine memdmp(jtape,memory,free,alloc)
      implicit none
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape,jtp
      integer memory(*),free,alloc,used,cumu,memxad,mxxad
      PARAMETER (mxxad=100)
      integer i,nm1,nm2
      character*4 status
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtp,
     *used,cumu,memxad(mxxad)
      if (free.eq.0) goto 33
      i=free
31    continue
      write (jtape,101) 'memmgr',i,memory(i+1),memory(i)
101   format(a8,'| free   ',i12,' L=',i12,' next:',i12)
      used=0
      i=memory(i)
      if (i.gt.0) goto 31
33    if (alloc.eq.0) goto 900
      i=alloc
32    continue
      used=used+memory(i+1)
      nm1=memory(i+memory(i+1)-2)
      nm2=memory(i+memory(i+1)-1)
      if (memory(i+2).ne.nm1 .or. memory(i+3).ne.nm2) then
       status='crap'
      else
       status='OK  '
      endif
      write (jtape,100)
     * 'memmgr',i,memory(i+1),memory(i+2),memory(i+3),status,memory(i)
100   format(a8,'| in use ',i12,' L=',i12,' [',a4,a4,'] ',a,' next:',
     *i12)
      i=memory(i)
      if (i.gt.0) goto 32
900   continue
      if (cumu.lt.used) cumu=used
      write (jtape,301) 'memmgr',used,cumu
301   format(a8,'|',i12,' words currently allocated,  ',i12,' max use.')
      return
      end
      subroutine memact(iopt,name)
      IMPLICIT none
*
      INTEGER memget,memfre,memrep,memini,memmax,memchk,
     *memclp,memgdw,memfdw,iprmck,iprmpr,iprnof,mxxad
      parameter (memget=2,memfre=4,memrep=8,memini=16,memmax=32,
     *memclp=64,memgdw=128,memfdw=256,memchk=512)
      parameter (iprmpr=1,iprmck=2,iprnof=4,mxxad=100)
      integer iprmem,imgrdm,nlongr,nwordl,idbg,jtape,memxad,cumu,used
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
*
      character*(*) name
      integer iopt
      if (iopt.eq.memget) write (jtape,*) '          memget: ',name
      if (iopt.eq.memfre) write (jtape,*) '          memfre: ',name
      if (iopt.eq.memrep) write (jtape,*) '          memrep: ',name
      if (iopt.eq.memini) write (jtape,*) '          memini: ',name
      if (iopt.eq.memmax) write (jtape,*) '          memmax: ',name
      if (iopt.eq.memclp) write (jtape,*) '          memclp: ',name
      if (iopt.eq.memgdw) write (jtape,*) '          memgdw: ',name
      if (iopt.eq.memfdw) write (jtape,*) '          memfdw: ',name
      if (iopt.eq.memchk) write (jtape,*) '          memchk: ',name
      return
      end
      subroutine memck(nalloc,memory,free,alloc,iopt,name,ixad)
      IMPLICIT none
      integer iopt,ixad
      integer memory(*),free,alloc,nalloc
      integer i,n,in1,in2,used,cumu,memxad,mxxad
      parameter (mxxad=100)
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
      character*(*) name
      character*8 xn
      logical crap
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape
      crap=.false.
* to prevent crashes, test known locations first
50    continue
      do 41 n=1,ixad
       i=memxad(n)
       if (i.gt.0) then
        write (xn,'(2A4)') memory(i+2),memory(i+3)
        if (crap) write (jtape,'(A,I10,3X,2A)')
     *   '   memck|       @',i,xn,' ...'
        if (xn(7:8).ne.'>>')  then
         write (jtape,'(A,I10,3X,2A)')
     *    '   memck| crap: @',i,xn,' ...'
         call memdb6('6 words before start of array',
     *    memory(i),memory(i))
         if (.not.crap) then
          crap=.true.
          write (jtape,'(A,I10,2A)') '   memck| repeating scan ...'
          goto 50
         endif
        else
         in1=memory(i+memory(i+1)-2)
         in2=memory(i+memory(i+1)-1)
         if (memory(i+2).ne.in1 .or. memory(i+3).ne.in2) then
          write (jtape,'(A,I10,3X,2A)') '   memck|       @',i,xn,
     *     ' written beyond bounds ...'
          call memdb6('after end of array',
     *     memory(i+memory(i+1)-2),memory(i+memory(i+1)-2))
          if (.not.crap) then
           crap=.true.
           write (jtape,'(A,I10,2A)') '   memck| repeating scan ...'
           goto 50
          endif
         endif
        endif
       endif
41    continue
      if (crap) goto 19
      n=0
      i=alloc
      used=0
32    if (i.le.0) goto 10
      used=used+memory(i+1)
      in1=memory(i+memory(i+1)-2)
      in2=memory(i+memory(i+1)-1)
      if (memory(i+2).ne.in1 .or. memory(i+3).ne.in2) then
       write (jtape,401) i,memory(i),memory(i+1),memory(i+2),
     * memory(i+3),memory(in1),memory(in2)
  401  format('  memck |   ',3i10,1x,'[',2a4,'] ...  [',2a4,']')
       goto 10
      endif
      n=n+1
      i=memory(i)
      goto 32
10    continue
      if (cumu.lt.used) then
       cumu=used
      endif
      if (n.eq.nalloc) return
19    write (jtape,'(A)') '   memck| ******************************'
      write (jtape,'(A)') '   memck| * memory structure corrupted *'
      write (jtape,'(A)') '   memck| ******************************'
      write (jtape,'(A,I10)') '   memck| action in progress:'
      call memact(iopt,name)
      call errex(' memmgr| memory structure corrupted')
      return
      end
      subroutine memgbc(memory,free,lpr)
c      collapse adjacent chunks
      implicit none
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape,mxxad,memxad,
     *used,cumu
      parameter (mxxad=100)
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
      integer memory(*),free
      logical lpr
      integer i,prev,j,qrev
c
c      return here if some chunks have been collapsed
c
20    i=free
      prev=0
32    continue
c@    WRITE (jtape,401) prev,i,memory(i),memory(i+1),memory(i+2),memory(i+3)
c@401 FORMAT('  memgbc@32 ',4I10,'[',2A4,']')
      if (i.le.0) goto 10
c
c      is this chunk at the end of a second one?
c
      j=free
      qrev=0
33    if (j.le.0) goto 34
      if (memory(j+1).eq.0) then
       write (jtape,100) 'memgbc',j,memory(j+1)
       call errex(' memmgr: zero length memory chunk found.')
      endif
      if (j+memory(j+1).eq.i) then
       if (lpr) write (idbg,100) 'memgbc',j,memory(j+1),i
  100  format(a8,'| ',i10,'@ [',i10,'] and ',i10,'@ fused.')
       memory(j+1)=memory(j+1)+memory(i+1)
       call memdeq(memory,free,qrev,j)
       if (prev.ne.j) then
        call memdeq(memory,free,prev,i)
       else
        call memdeq(memory,free,qrev,i)
       endif
       call memenq(memory,free,0,j)
c@     CALL memdmp(6,memory,free,0)
       goto 20
      endif
      qrev=j
      j=memory(j)
      goto 33
34    continue
      if (i.eq.0) goto 10
      prev=i
      i=memory(i)
      goto 32
10    continue
      return
      end
      subroutine memenq(memory,free,prev,j)
      implicit none
      integer memory(*),free,prev,j
      if (prev.eq.0) then
       memory(j)=free
       free=j
      else
       memory(j)=memory(prev)
       memory(prev)=j
      endif
      return
      end
      subroutine memdeq(memory,queue,prev,j)
      implicit none
      integer memory(*),queue,prev,j
      if (prev.eq.0) then
       queue=memory(j)
      else
       memory(prev)=memory(j)
      endif
      return
      end
      subroutine memdb6(t,a,m)
      implicit none
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape
      integer used,cumu,memxad,mxxad
      parameter (mxxad=100)
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
      real*8 a(6)
      integer m(6)
      character*(*) t
      write (jtape,'(2A)') '   memck|  dumping memory ',t
      write (jtape,'(6(''['',Z8,'']''))') m
      write (jtape,'(3(''['',D18.10,'']''))') a
      write (jtape,'(6(''['',I8,'']''))') m
      write (jtape,'(6(''['',A4,'']''))') m
      return
      end
      SUBROUTINE memchk(in,tx)
      IMPLICIT none
      CHARACTER*(*) tx
      INTEGER in(*)
      INTEGER n,l
      INTEGER iprmem,imgrdm,nlongr,nwordl,idbg,jtape
      integer used,cumu,memxad,mxxad
      parameter (mxxad=100)
      common /memcmn/ iprmem,imgrdm,nlongr,nwordl,idbg,jtape,
     *used,cumu,memxad(mxxad)
      n=-2
      l=in(n)-6
      n=-1
      IF (in(n).NE.0 .AND. in(n).EQ.in(l+1) .AND.
     *  in(n+1).EQ.in(l+2)) THEN
       WRITE (jtape,100) '  memchk| ',in(n),in(n+1),l,'   OK: ',tx
100    FORMAT(A,2A4,'[',I10,']',2A)
      ELSE
       WRITE (jtape,100) '  memchk| ',in(n),in(n+1),l,' crap: ',tx
       CALL errex('memory structure destroyed')
      ENDIF
      RETURN
      END
