CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE nodeini
*
* check virtual machine and see which nodes are there; this subroutine is
* called at the very beginning of the master process, even before the input
* file is read.
*
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INCLUDE 'objects.h'
      INCLUDE 'sadmch.h'

      INTEGER nnode

      CHARACTER*40 newnode,name
      CHARACTER*255 newarch
C#    CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiname
      INTEGER newtid,narch,info,newspeed
      INTEGER i,k,l,idum,tid,p,pp,num_pes

* get number of nodes in virtual machine
C//SKIPC#3
      CALL PVMFCONFIG(nnode,narch,mastertid,masternode,
     * newarch,newspeed,info)

C#    CALL MPI_COMM_SIZE( MPI_COMM_WORLD, nnode, info )
C#    CALL mpierr('MPI_COMM_SIZE','nodeini',info)
C#    WRITE (idbg,*) '@nodeini@ nnode=',nnode
C#    CALL flush(idbg)
C#    CALL MPI_GET_PROCESSOR_NAME(mpiname,l,info)
C#    CALL mpierr('MPI_GET_PROCESSOR_NAME','nodeini',info)
C#    WRITE (idbg,*) '@nodeini@ running on ',mpiname(1:l)
C#    CALL flush(idbg)
C#    CALL clean(masternode)
C#    masternode=mpiname(1:l)
C#    nnode=nnode-1
      IF (nnode.EQ.0) CALL errex('no nodes found to work on')

      CALL clean(masterid)
      masterid=masternode
      CALL llen(masterid,li)

      WRITE (jtape,*) 'master node is ',masternode
      WRITE (idbg,*) 'nodeini| master node is ',masternode
      WRITE (idbg,*) '       | ',nnode,' node(s) in virtual machine'
      CALL flush(jtape)

* loop through nodes

      DO i=1,nnode
C//SKIPC#1
       CALL PVMFCONFIG(idum,narch,tid,newnode,newarch,newspeed,info)
C#     tid=i
C#     CALL clean(newnode)
C#     CALL clean(newarch)
C#     WRITE (newnode,'(I4.4)') i
       k=1
C//SKIPC%1
       k=NUM_PES()-1
       DO l=1,k
C//SKIPC#1
        CALL sadmch_new(pvmmch,newnode,newarch)
C#      CALL sadmch_new(pmch,newnode,newarch)
        is(cmch+sadmch_tid)=i
        WRITE (idbg,*) 'nodeini| virtual node ',newnode
       ENDDO 
      ENDDO

      IF (nnode.GT.0)
     *WRITE (idbg,*) '       | ###### nodes in virtual machine ######'
C//SKIPC#1
      p=pvmmch
C#    p=pmch
40    IF (p.EQ.0) GOTO 900
      CALL sadmch_dmp(idbg,p)
      p=is(p+sadmch_next)
      GOTO 40

900   CALL flush(idbg)
      RETURN
C#    END
C#    SUBROUTINE mpierr(f,p,n)
C#    INCLUDE 'defs.h'
C#    INCLUDE 'comm.h'
C#    CHARACTER*(*) f,p
C#    INTEGER n
C@    WRITE (jtape,*) p,' (',f,'); error code is ',n
C@    CALL flush(jtape)
C#    IF (n.EQ.MPI_SUCCESS) RETURN
C#    WRITE (jtape,*) 'MPI error in ',p,' (',f,')'
C#    WRITE (jtape,'(A,I16,A,Z16,A)') ' error code is ',n,'(',n,')'
C#    CALL errex('mpi error')
C#    RETURN
      END
