CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE parstuff(g,dip,pol,gra,stepfl,vmach)
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INCLUDE 'objects.h'
      INCLUDE 'sadmch.h'
*
* g      R8  short gradient buffer (1:nvar)
* dip    R8  dipole buffer
* pol    R8  polarizability buffer
* gra    R8  gradient buffer
* stepfl I4  status flags for each point
* vmach  R8  machine name for each point
*

      INTEGER stepfl(*)
      REAL*8 g(nvar),dip(*),pol(*),gra(*),vmach(*)

* declare integers to be packed and unpacked as INTEGER*4 for T3E compatibility
      INTEGER*4 iwhat,itst,pid
      CHARACTER*40 newnode
      CHARACTER*255 newarch
      INTEGER info
      INTEGER i,k,l,idum,mbuf,ize,ipe,iprc,p,nnode
C#    INTEGER st(MPI_STATUS_SIZE)
C#    INTEGER w
C#    DATA w /MPI_COMM_WORLD/

888   p=pmch
20    IF (p.EQ.0) GOTO 21      
      CALL howmany(ize,ipe,iprc,stepfl)
C@    WRITE (idbg,*) '@parstuff ize, ipe, iprc ',ize,ipe,iprc,p
C//SKIPC#1
      IF (ize.GT.0) CALL spawn(p,jtape)
C#    IF (ize.EQ.0 .AND. is(p+sadmch_nodf).EQ.sadmch_rdy) THEN
C#     CALL remnode(p,'shutdown[idle]',0,stepfl)
C#    ENDIF
      CALL fsys(stepfl)
      CALL grant_ctok
      CALL readcmd
      CALL trace_stat
      CALL ssend(p,dip,pol,gra,stepfl,vmach)
      CALL getres(p,g,dip,pol,gra,stepfl,vmach)
      p=is(p+sadmch_next)
      GOTO 20

21    CONTINUE
      CALL sleep(1)

      CALL howmany(ize,ipe,iprc,stepfl)
C@    WRITE (idbg,*) '@parstuff ize, ipe, iprc ',ize,ipe,iprc
      CALL flush(idbg)

      IF (ize+ipe.NE.0 .AND. iprc.NE.0) goto 888

      RETURN
      END
