CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE pgetstr(t,s,tid,l,id,irc)
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INTEGER tid,l,irc,id
      CHARACTER*(*) s,t
      INTEGER w
C#    INTEGER st(MPI_STATUS_SIZE)
C#    CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiname

C#    w=MPI_COMM_WORLD
C@    WRITE (idbg,*) '@pgetstr@ ',id,'{',tid,'} [',t,']'
C@    CALL flush(idbg)
C***  CALL MPI_RECV(l,1,MPI_INTEGER,tid,id,w,st,irc)
C***  CALL mpierr('MPI_RECV pgetstr',t,irc)
C#    CALL MPI_RECV(s,l,MPI_CHARACTER,tid,id,w,st,irc)
C#    CALL mpierr('MPI_RECV pgetstr',t,irc)
C//SKIPC#
      CALL PVMFRECV(tid,0,w)
      CALL clean(s)
      CALL PVMFUNPACK(STRING,s,l,1,irc)
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
C//END
      RETURN
      END
      SUBROUTINE pputstr(t,s,tid,l,id,irc)
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INTEGER tid,l,irc,id
      CHARACTER*(*) s,t
      INTEGER w
C#    INTEGER st(MPI_STATUS_SIZE)
C@    WRITE (idbg,*) '@pputstr@ ',id,'{',tid,'} [',t,']'
C@    CALL flush(idbg)
C#    w=MPI_COMM_WORLD
C***  CALL MPI_SSEND(l,1,MPI_INTEGER,tid,id,w,irc)
C:    CALL MPI_SSEND(s,l,MPI_CHARACTER,tid,id,w,irc)
C:    CALL mpierr('MPI_SSEND pputstr',t,irc)
C//SKIPC:2
C***  CALL MPI_SEND(l,1,MPI_INTEGER,tid,id,w,irc)
C#    CALL MPI_SEND(s,l,MPI_CHARACTER,tid,id,w,irc)
C#    CALL mpierr('MPI_SEND pputstr',t,irc)
C//SKIPC#
      CALL PVMFINITSEND(PVMDATADEFAULT,w)
      CALL PVMFPACK(STRING, s, l, 1, irc )
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
      CALL PVMFSEND( tid, 0, irc )
      IF (irc.NE.0) CALL PVMFPERROR(t,irc)
C//END
      RETURN
      END
