CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rcontrol(tempname,natoms,mode,inputdip,inputpol,
     .            cstep,jscfc,isuhf,iomeg,mxomeg,omeg,naus,iclean,
     .            icleanl,dalmw,idalmw,snffast,idbg)
      implicit none
      real*8 xx,cstep,getreal
      integer naus,lu,mode,inputdip,inputpol,i,n,natoms,idbg,lmod
      integer iclean,icleanl
      external getreal
      character*1 tmptxt
      character*4 mform
      logical ridft,snffast
      character*(*) tempname
      character*20 a20
      INTEGER mxitem
      PARAMETER (mxitem=12)
      INTEGER jscfc,intgr,isuhf,iomeg,mxomeg,ist,ien,idalmw
      character*80 dalmw
      CHARACTER*255 b1
      CHARACTER*255 item(mxitem)
      REAL*8 omeg(*)
      dimension xx(2)

      lu=1
      IF (mxitem.NE.mxomeg+2) THEN
       CALL errex('set mxitem to mxomeg+2 in rcontrol')
      ENDIF
C@    WRITE (idbg,*) 'reading <control> from ',tempname
      OPEN (UNIT=lu,FILE=tempname,STATUS='UNKNOWN')
      mode=1
      inputdip=0
      inputpol=0
      cstep=0.01
      ridft=.false.
      snffast=.false.
      iclean=0
      icleanl=0

1     READ (lu,'(A)',END=999) b1
      if(index(b1,'1st').ne.0) inputdip=1
      if(index(b1,'$scfinstab').ne.0) THEN
       if(index(b1,'polly').ne.0) inputpol=1
       IF (index(b1,'dynpol').ne.0) THEN
* read the frequencies
        CALL split(b1,item,mxitem)
        DO iomeg=3,mxitem
         IF (item(iomeg)(1:1).EQ.' ') GOTO 2
         ist=1
         omeg(iomeg-2)=getreal(item(iomeg),ist,ien)
        ENDDO
        iomeg=mxitem+1
2       iomeg=iomeg-3
        inputpol=2
       ENDIF
*      WRITE (idbg,*) 'INPUTPOL=',inputpol,' IOMEG=',iomeg
      ENDIF
      if(index(b1,'$scfconv').ne.0) THEN
       jscfc=intgr(b1(10:),i,20)
      ENDIF
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      if(index(b1,'$tmpdirclean').ne.0) iclean=1
      if(index(b1,'$logdirclean').ne.0) icleanl=1
      if(index(b1,'$ridft').ne.0) ridft=.true.
      if(index(b1,'$snffast').ne.0) snffast=.true.
      if(index(b1,'$uhf').ne.0) isuhf=1
      if(index(b1,'rimp2').ne.0) mode=3
      if(index(b1,'traloop').ne.0) mode=4
      if(index(b1,'$workescf.intel').ne.0) mode=5
      if(index(b1,'$workescf.athlon').ne.0) mode=6
      if(index(b1,'$dalmw').ne.0) then
        read(b1(8:),*) dalmw
        read(dalmw,*) idalmw
      end if
      if(index(b1,'$daltonmode').ne.0) then
        call clean(item(2))
        call split(b1,item,mxitem)
        tmptxt=' '
        mform='    '
        call llen(item(2),lmod)
        if(lmod.gt.9) stop 'error: mode too large'
        write(tmptxt,'(i1)') lmod
        mform='(i'//tmptxt//')'
        read(item(2),mform) mode
      end if
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if(index(b1,'natoms=').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       natoms=int(xx(1))
      endif
      if(index(b1,'cstep').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       cstep=xx(1)
      endif
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      if(index(b1,'numderiv').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       naus=xx(1)
       naus=naus*2
      endif
      GOTO 1
999   if(natoms.lt.2) stop 'natoms < 2. stop in rcontrol'
      if(ridft) then
        if(mode.eq.5) then
          mode=7
        else if(mode.eq.6) then
          mode=8
        else
          mode=2
        end if
      end if
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      CLOSE (UNIT=lu)
      return
      end
