CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine rcoord(tempname,natoms,co,ic)
C
C     read TURBOMOLE coord file and determine 
C     nuclear charge numbers
C
C     natoms = number of atoms
C     co     = cartesian coordinates of atoms
C     ic     = nuclear charge numbers (integer)
C
C     written by J. Neugebauer, Uni Erlangen, 01/2002
C     
      implicit none
      double precision co(3,*)
      integer ic(*),i,lu,find_nucl_charge,natoms,ltmp,idbg
      character*(*) tempname
      character*2   element
      character*255 b1
      external find_nucl_charge
      idbg=6
      lu=1
      call slen(tempname,ltmp)
      write(idbg,*) 'rcoord: reading coordinates from file: ',
     * tempname(1:ltmp)
      open (unit=lu,file=tempname(1:ltmp),status='unknown',err=1001)
      do
        read (lu,'(a)',end=999) b1
        if (b1(1:6).eq.'$coord') exit
      enddo
      natoms=0
      do
        read (lu,'(a)',end=999) b1
        if(b1(1:1).eq.'$') exit
        natoms=natoms+1
        read(b1,*) co(1,natoms), co(2,natoms), co(3,natoms), element
        ic(natoms)=find_nucl_charge(element)
      enddo
      write(idbg,*) 'rcoord: natoms = ',natoms
999   close(lu)
1001  continue
      return
      end
      
      subroutine pcoord(natoms,co,ic,out)
C
C     print molecule information
C
C     written by J. Neugebauer, Uni Erlangen, 01/2002

      implicit none
      double precision co(3,*),find_mass
      integer ic(*),i,natoms,out,j
      character*2   find_element
      external find_element,find_mass 
      write(out,*) 
      write(out,*) '  General Molecule Information: '
      write(out,*) '  ----------------------------- '
      write(out,*) 
      write(out,'("   No El  OZ",12x,"m",15x,"x",15x,"y",15x,"z")')
      do i=1,natoms
        write(out,'(''   '',i2,1x,a2,1x,i3,f13.6,3e16.8)') i,
     * find_element(ic(i)),ic(i),find_mass(ic(i)),
     * (co(j,i),j=1,3)
      end do
      write(out,*) 
      write(out,*) 
      return
      end 

      subroutine wcoord(tempname,natoms,co,ic)
C
C     write TURBOMOLE coord file
C 
C     written by J. Neugebauer, Uni Erlangen, 01/2002

      implicit none
      double precision co(3,*)
      integer ic(*),i,lu,natoms
      character*(*) tempname
      character*2   find_element
      external find_element
      lu=44
      open (unit=lu,file=tempname,status='unknown',err=1001)
      write(44,'(''$coord'')')
      do i=1,natoms
        write(lu,300) co(1,i), co(2,i), co(3,i), find_element(ic(i))
      enddo
      write(44,'(''$end'')')
      close(lu)
300   format(3f18.10,5x,a2)
1001  return
      end

      
