CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rduse
* remove all dead and unfit nodes, read  USE_NODES file and spawn all nodes
* specified there, unless a suitable number of processes is already running
* on the node in question.
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER lu
      CHARACTER*255 rec,item(mxitem)
      CHARACTER*40 name
      INTEGER p,i,l,kp,np,intgr,valid,maxp
      LOGICAL yes

      lu=1
      CALL clean(rec)
      CALL cmd_remove(rec)

      INQUIRE (FILE='USE_NODES',EXIST=yes)
      IF (.NOT.yes) THEN
       WRITE (idbg,*) '  rduse| file USE_NODES not present'
       WRITE (jtape,*) '########'
       WRITE (jtape,*) '######## file USE_NODES not present'
       WRITE (jtape,*) '########'
       RETURN
      ENDIF
      OPEN (UNIT=lu,FILE='USE_NODES',STATUS='UNKNOWN')
      WRITE (idbg,*) '  rduse| reading file USE_NODES'

90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'node') THEN
       WRITE (idbg,*) '  rduse| ',rec(1:60)
       np=0
       p=pmch
       CALL llen(item(2),l)
       kp=intgr(item(3),i,20)
       maxp=intgr(item(4),i,20)
       if (maxp.EQ.0) maxp=1
1      IF (p.EQ.0) GOTO 2
       CALL sadmch_gname(p,name)
       IF (name(1:l).EQ.item(2)(1:l)) THEN
         valid=0
         IF (is(p+sadmch_cmd).EQ.sadmch_vbsy) is(p+sadmch_cmd)=0
         IF (is(p+sadmch_nodf).EQ.sadmch_rdy) valid=valid+1
         IF (is(p+sadmch_nodf).EQ.sadmch_wait) valid=valid+1
         IF (is(p+sadmch_nodf).EQ.sadmch_runn) valid=valid+1
         IF (valid.GT.0) THEN
          CALL sadmch_fname(pvmmch,name)
          IF (cmch.GT.0) is(cmch+sadmch_mxlo)=maxp*150
          np=np+1
         ENDIF
       ENDIF
       p=is(p+sadmch_next)
       GOTO 1
2      kp=kp-np
       IF (kp.GT.0) THEN
        WRITE (idbg,*)
     *   '       | creating ',kp,' more process(es) on ',item(2)(1:20)
        DO i=1,kp
         CALL sadmch_new(pmch,item(2),' ')
         is(cmch+sadmch_mxlo)=maxp*150
        ENDDO
       ENDIF
      ENDIF
      GOTO 90
99    CLOSE (UNIT=lu)
      RETURN
      END
