CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE readcmd
*
* read commands to drive the virtual machine from file DC
*
* SHUTDOWN <empty>|<node>|<jobno>   shut down (i.e., run current job
*                                   and deactivate node after it is
*                                   finished
* TERM     <empty>|<node>|<jobno>   terminate node
* REMOVE   <empty>|       <jobno>   remove slot from use
* SPAWN    <empty>|<node>           spawn node or read USE_NODES
* FSYS     <0><1>                   switch off/on fsystem reporting
* CLEAR    <empty>|<node>|<jobno>   clear pending cmds
* UPDATE   <empty>|<opt>            sum of 1 to remove vbsy, 2 to add idle nodes
* TMPDIR   <dirname>                change TMPDIR to <dirname>
* TMPDIR(<node>) <dirname>          change TMPDIR of <node> to <path>
* DCPATH   <path>                   change DCPATH to <dirname>
* DCPATH(<node>) <path>             change DCPATH of <node> to <path>
**
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lupvm,iostat,irc
      CHARACTER*255 rec,item(mxitem)
      CHARACTER*255 filename
      CHARACTER*24 date
      INTEGER i,k,l,ip,knrec
      LOGICAL ex
      CALL clean(filename)
      filename=mydir(1:lm)//'/DC'
      INQUIRE (FILE=filename,EXIST=ex)
      IF (.NOT.ex) RETURN
** read file into memory and delete file
      knrec=0
      lupvm=1
      OPEN (UNIT=lupvm,FILE=filename,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    CONTINUE
      knrec=knrec+1
      IF (knrec.GT.mxinfi) THEN
       WRITE (*,*)
     *   '* number of cmd records exceeds maximum of ',mxinfi
       GOTO 99
      ENDIF
      READ (lupvm,'(A)',END=99) incmd(knrec)
      GOTO 90
99    knrec=knrec-1
      CLOSE (UNIT=lupvm,STATUS='DELETE')
      DO k=1,knrec
       CALL llen(incmd(k),l)
       CALL fdate(date)
       WRITE (*,'(3A)') date,' readcmd: ',incmd(k)(1:l)
       CALL split(incmd(k),item,mxitem)
       CALL upper(item(1))
       CALL llen(item(1),l)
       IF (item(1)(1:l).EQ.'FSYS') CALL cmd_fsys(item)
C%     IF (item(1)(1:l).EQ.'SHUT') CALL cmd_shut(item)
C%     IF (item(1)(1:l).EQ.'SHUTDOWN') CALL cmd_shut(item)
C%     IF (item(1)(1:l).EQ.'TERM') CALL cmd_kill(item)
C%     IF (item(1)(1:l).EQ.'SPAWN') CALL cmd_spawn(item(2))
       IF (item(1)(1:l).EQ.'CLEAR') CALL cmd_clear(item)
       IF (item(1)(1:l).EQ.'REMOVE') CALL cmd_remove(item(2))
       IF (item(1)(1:6).EQ.'TMPDIR') CALL cmd_addinp(incmd(k))
       IF (item(1)(1:6).EQ.'DCPATH') CALL cmd_addinp(incmd(k))
       IF (item(1)(1:6).EQ.'UPDATE') CALL cmd_update(item(2))
      ENDDO
      RETURN
      END

      SUBROUTINE cmd_shut(item)
      IMPLICIT none
      CHARACTER*255 item(*)
      INCLUDE 'sadmch.h'
      CALL cmd_gcmd(item,sadmch_shut)
      RETURN
      END
      SUBROUTINE cmd_kill(item)
      IMPLICIT none
      CHARACTER*255 item(*)
      INCLUDE 'sadmch.h'
      CALL cmd_gcmd(item,sadmch_term)
      RETURN
      END
      SUBROUTINE cmd_clear(item)
      IMPLICIT none
      CHARACTER*255 item(*)
      INCLUDE 'sadmch.h'
      CALL cmd_gcmd(item,0)
      RETURN
      END
      SUBROUTINE cmd_spawn(arg)
      INCLUDE 'defs.h'
      CHARACTER*255 arg
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER info,xeq
      LOGICAL yes
      IF (arg.EQ.' ') THEN
       info=xeq('choose_nodes')
       CALL rduse
       RETURN
      ENDIF
      CALL sadmch_new(pmch,arg,' ')
      RETURN
      END
      SUBROUTINE cmd_fsys(item)
      IMPLICIT none
      CHARACTER*255 item(*)
      INCLUDE 'param.h'
      INTEGER i,intgr
      i=1
      iprintf=intgr(item(2),i,20)
      RETURN
      END
      SUBROUTINE cmd_remove(ans)
      INCLUDE 'defs.h'
      CHARACTER*255 ans
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER i,p,intgr,info
      IF (ans.EQ.' ') THEN
       p=pmch
1      IF (p.EQ.0) RETURN
       IF (is(p+sadmch_nodf).EQ.sadmch_dead)
     *  is(p+sadmch_nodf)=sadmch_remo
       IF (is(p+sadmch_nodf).EQ.sadmch_unf )
     *  is(p+sadmch_nodf)=sadmch_remo
       IF (is(p+sadmch_nodf).EQ.sadmch_pvme)
     *  is(p+sadmch_nodf)=sadmch_remo
       p=is(p+sadmch_next)
       GOTO 1
      ENDIF
      i=1
      info=intgr(ans,i,20)
      CALL sadmch_fnum(info)
      IF (cmch.NE.0) THEN
       IF (is(cmch+sadmch_nodf).EQ.sadmch_dead)
     *  is(cmch+sadmch_nodf)=sadmch_remo
       IF (is(cmch+sadmch_nodf).EQ.sadmch_unf )
     *  is(cmch+sadmch_nodf)=sadmch_remo
       IF (is(cmch+sadmch_nodf).EQ.sadmch_pvme)
     *  is(cmch+sadmch_nodf)=sadmch_remo
      ENDIF
      RETURN
      END
      SUBROUTINE cmd_addinp(rec)
      IMPLICIT none
      INCLUDE 'param.h'
      CHARACTER*255 rec
      INTEGER i,l1,l2,info
      CHARACTER*255 item(2),jtem(2)
** check if same command is already present on input file
      CALL split(rec,item,2)
      CALL llen(item(1),l1)
      DO i=1,inrec
       CALL split(infi(i),jtem,2)
       CALL llen(jtem(1),l2)
       IF (item(1)(1:l1).EQ.jtem(1)(1:l2)) THEN
        WRITE (*,*) 'cmd_addinp: replacing input record'
        CALL llen(infi(i),l2)
        CALL llen(rec,l1)
        WRITE (*,*) 'old: ',infi(i)(1:l2)
        WRITE (*,*) 'new: ',rec(1:l1)
        infi(i)=rec
        RETURN
       ENDIF
      ENDDO
      inrec=inrec+1
      IF (inrec.GT.mxinfi) THEN
       WRITE (*,*)
     *   '* number of input records exceeds maximum of ',mxinfi
       WRITE (*,*) '* increase mxinfi in util.r[readin] and recompile'
       CALL errex('too many input records')
      ENDIF
      infi(inrec)=rec
      RETURN
      END
      SUBROUTINE cmd_gcmd(item,mycmd)
      INCLUDE 'defs.h'
      CHARACTER*255 item(*)
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER i,p,l,intgr,mycmd,thejob
      LOGICAL numric
      IF (item(2).EQ.' ') THEN
       p=pmch
1      IF (p.EQ.0) RETURN
       is(p+sadmch_cmd)=mycmd
       p=is(p+sadmch_next)
       GOTO 1
      ENDIF
      IF (numric(item(2)(1:1))) THEN
       i=1
       thejob=intgr(item(2),i,20)
       CALL sadmch_fnum(thejob)
       IF (cmch.NE.0) THEN
        is(cmch+sadmch_cmd)=mycmd
       ELSE
        WRITE (jtape,*) '-------> job #',thejob,' not found'
       ENDIF
       RETURN
      ENDIF
      CALL llen(item(2),l)
      p=pmch
3     CALL sadmch_fname(p,item(2))
      IF (cmch.EQ.0) RETURN
      is(cmch+sadmch_cmd)=mycmd
      p=is(cmch+sadmch_next)
      GOTO 3
      END
      SUBROUTINE cmd_update(rec)
      INCLUDE 'defs.h'
      CHARACTER*255 rec
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER i,l,intgr
      LOGICAL numric
      IF (rec.EQ.' ') THEN
       updopt=3
       CALL updvm(updopt)
       RETURN
      ENDIF
      updopt=intgr(rec,i,20)
      CALL updvm(updopt)
      RETURN
      END
