CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE remnode(p,msg,imsg,stepfl)
**
** remove node
**
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER stepfl(*)
      INTEGER p,imsg,mbuf
      CHARACTER*(*) msg
      CHARACTER*24 date
      INTEGER j,k,mbua,info
      CHARACTER*40 myname
      CHARACTER*255 cmd
      CHARACTER*20 cpid
      INTEGER*4 iwhat
      INTEGER i,ist,tid,tpid,xeq
C#    INTEGER w,st(MPI_STATUS_SIZE)
C#    DATA w /MPI_COMM_WORLD/
      CALL sadmch_gname(p,myname)
      CALL fdate(date)
      WRITE (jtape,'(A,A,I10,X,A,X,A,X,I3)')
     .     date,'!! ',is(p+sadmch_numb),myname(1:10),msg,imsg
      IF (imsg.EQ.0) THEN
       is(p+sadmch_nodf)=sadmch_done
      ELSE
       is(p+sadmch_nodf)=sadmch_dead
      ENDIF
      is(p+sadmch_cmd )=0
      i=is(p+sadmch_stpa)
      j=is(p+sadmch_stpb)
      tid=is(p+sadmch_tid)
      CALL sadmch_fname(pvmmch,myname)
      ist=0
      IF (cmch.GT.0) ist=is(cmch+sadmch_usag)
      IF (imsg.GT.0 .AND. i.GT.0) THEN
       stepfl(i)=0
       DO k=i,j
        stepfl(k)=0
       ENDDO
      ENDIF
      IF (imsg.EQ.sadmch_term) THEN
       tpid=is(p+sadmch_tpid)
       IF (tpid.NE.0) THEN
        WRITE (jtape,*) i,tid,tpid,' still running on ',myname
        WRITE (jtape,'(A,A,I10)')
     .       date,'!! trying to kill task ',tpid
        WRITE (cpid,'(I20)') tpid
        CALL clean(cmd)
        cmd='dc_killtask '//myname//' '//cpid//' TMP_dc_killtask'
        info=xeq(cmd)
        WRITE (jtape,'(A,A,I10)')
     .       date,'!! returncode was ',info
       ENDIF
      ENDIF
      iwhat=-1
C#    CALL MPI_SEND(iwhat,1,MPI_INTEGER,tid,409,w,info)
C#    CALL mpierr('MPI_SEND iwhat','remnode',info)
C//SKIPC#
      CALL PVMFINITSEND(PVMDATADEFAULT,mbuf)
      CALL PVMFPACK( INTEGER4, iwhat, 1, 1, info )
      CALL PVMFSEND( tid, 0, info )
      WRITE (jtape,'(''percentage of work done on node '',
     * a20,F10.2)') myname,100.*float(ist)/float(nstept)
C//END
      RETURN
      END
