CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine wrestart(vmach,dip,pol,gra,istepfl)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      CHARACTER*255 form
      INTEGER istepfl(*)
      REAL*8 dip(*)
      REAL*8 pol(mxomeg,*)
      REAL*8 gra(*)
      REAL*8 vmach(*)
      INTEGER i,j,k,in1,ires,imin,inul,ione,jomeg
      CHARACTER*24 date
      INCLUDE 'VERSION.h'
      DATA form /'(4D20.10)'/
      in1=88
      CALL howmany(inul,ione,i,istepfl)
      OPEN (unit=in1,file=restart,STATUS='UNKNOWN')
      WRITE (in1,'(A)') title
      WRITE (in1,'(A)') form
      WRITE (in1,'(14I5)') ivers,mode,inputpol,iomeg,nvar,
     * jscfc,naus,inul,ione
* iomeg          number of frequencies for frequency-dependent
*                polarizabilities
* inul           number of  0 step entries ('pending')
* ione           numner of  1 step entries ('done')
      WRITE (in1,form) cstep
      WRITE (in1,'(A)') mydir(1:lm)
      WRITE (in1,'(A)') tempdir(1:lm)
      DO i=1,natoms
       j=(i-1)*3*naus
       WRITE (in1,'(24I3)') i,(istepfl(k),k=j+1,j+naus*3)
       WRITE (in1,'(12A8)') (vmach(k),k=j+1,j+naus*3)
      ENDDO
      DO i=1,natoms
       WRITE (in1,*) 'dipoles atom',i
       j=(i-1)*3*naus*3
       WRITE (in1,form) (dip(k),k=j+1,j+naus*3*3)
      ENDDO
      DO i=1,natoms
       WRITE (in1,*) 'gradients atom',i
       j=(i-1)*3*naus*nvar
       WRITE (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
      ENDDO
*
* polarizabilities
*
      IF (inputpol.GT.0) THEN
       DO jomeg=1,ipol
        DO i=1,natoms
         j=(i-1)*3*naus*8
         WRITE (in1,'(a22,i8,a13,d20.10)') ' polarizabilities atom',i,
     *         ' frequency = ',omeg(jomeg)
         WRITE (in1,form) (pol(jomeg,k),k=j+1,j+naus*8*3)
        ENDDO
       ENDDO
      ENDIF

      CALL fdate(date)
      WRITE (in1,'(A)') date
**    WRITE (in1,'(A8,I8)') (vmach(k),is(pti+k-1),k=1,nnode)
      CLOSE (in1)
      RETURN
      END

      SUBROUTINE rrestart(vmach,dip,pol,gra,istepfl,isum)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER istepfl(*)
      CHARACTER*255 form,buf
      INTEGER i,j,k,isum,jvers,mmode,iaus,in1,inul,ione
      INTEGER jomeg,komeg
      LOGICAL ex
      REAL*8 pstep
      REAL*8 dip(*),vmach(*)
      REAL*8 pol(mxomeg,*)
      REAL*8 gra(*)
      INCLUDE 'VERSION.h'
      in1=88
      INQUIRE (FILE=restart,EXIST=ex)
      IF (.NOT.ex) RETURN

      OPEN (UNIT=in1,FILE=restart,STATUS='OLD')
      rewind(in1)
      READ(in1,'(A)')
      READ(in1,'(A)') form
      READ(in1,'(14I5)') jvers,mmode,inputpol,komeg,nvar,
     * jscfc,iaus,inul,ione
      i=ivers/10
      j=jvers/10
      IF (jvers.LT.170) THEN
       WRITE (*,*) '****** incompatible versions '
       WRITE (*,*) '****** version on restart file :',jvers
       WRITE (*,*) '****** current program version :',ivers
       CALL errex('incompatible restart file')
      ENDIF
      IF (mode.NE.mmode) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** mode on restart file :',mmode
       WRITE (*,*) '****** current program mode :',mode
       CALL errex('incompatible restart file')
      ENDIF
      IF (naus.NE.iaus) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** restart file is using ',iaus,' point formula'
       WRITE (*,*) '****** current program is using ',naus,
     * ' point formula'
       CALL errex('incompatible restart file')
      ENDIF
      READ (in1,form) pstep
      IF (DABS(cstep-pstep).GT.1.D-6) THEN
       WRITE (*,*) '****** cstep has been changed:'
       WRITE (*,*) '****** cstep on restart file     :',pstep
       WRITE (*,*) '****** current program cstepmode :',cstep
       CALL errex('incompatible restart file')
      ENDIF
      IF (IABS(iscfc-jscfc).GT.0) THEN
       WRITE (*,*) '****** scfconv has been changed:'
       WRITE (*,*) '****** scfconf on restart file     :',jscfc
       WRITE (*,*) '****** current program scfconv :',iscfc
       CALL errex('incompatible restart file')
      ENDIF
      READ (in1,'(A)') 
      READ (in1,'(A)') 
      DO i=1,natoms
       j=(i-1)*naus*3
       READ (in1,'(24I3)') k,(istepfl(k),k=j+1,j+naus*3)
       READ (in1,'(12A8)') (vmach(k),k=j+1,j+naus*3)
      ENDDO
      DO i=1,natoms
       READ (in1,'(A)')
       j=(i-1)*3*naus*3
       READ (in1,form) (dip(k),k=j+1,j+naus*3*3)
      ENDDO
      DO i=1,natoms
       READ (in1,'(A)')
       j=(i-1)*3*naus*nvar
       READ (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
      ENDDO
*
* polarizabilities
*
      IF (inputpol.GT.0) THEN
       DO jomeg=1,ipol
        DO i=1,natoms
         j=(i-1)*3*naus*8
         READ (in1,'(A)')
         READ (in1,form) (pol(jomeg,k),k=j+1,j+naus*8*3)
        ENDDO
       ENDDO
      ENDIF
 
      isum=0
      do i=1,nstept
         if(istepfl(i).eq.-1)istepfl(i)=0 
         isum=isum+istepfl(i) 
      enddo

      write(*,*)'% done yet',100.*float(isum)/float(nstept)

      close (in1)
      return
      end
