CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE sadmch_new(pp,name,arch)
*
* create new sadmch structure
*
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'objects.h'
      INCLUDE 'sadmch.h'
      CHARACTER*40 name
      CHARACTER*(*) arch
      INTEGER pp
* local
      INTEGER i,p,q,ql,next,nu
      CHARACTER*4 blank,def
      DATA blank /'    '/, def /'   A'/, next /0/

      CALL memmgr(memget,'sadmch  ',is,p,sadmch_len)
      READ (name,'(20A4)') (is(p+sadmch_name+i-1),i=1,10)
      READ (arch,'(20A4)') (is(p+sadmch_arch+i-1),i=1,2)
      WRITE (idbg,*) ' sadmch| [new] at ',p
      WRITE (idbg,'(A,20A4)')
     * '        | ', (is(p+sadmch_name+i-1),i=1,10)
      WRITE (idbg,'(A,20A4)')
     * '        | ', (is(p+sadmch_arch+i-1),i=1,2)

*
* enqueue this machine in machine list
*
      IF (pp.EQ.0) THEN
       pp=p
      ELSE
       q=pp
1      IF (q.NE.0) THEN
        IF (is(q+sadmch_nodf).EQ.sadmch_remo) THEN
         CALL memmgr(memfre,'sadmch  ',is,p,sadmch_len)
         READ (name,'(20A4)') (is(q+sadmch_name+i-1),i=1,10)
         READ (arch,'(20A4)') (is(q+sadmch_arch+i-1),i=1,2)
         nu=is(q+sadmch_numb)
         p=q
         GOTO 2
        ENDIF
        ql=q
        q=is(ql+sadmch_next)
        GOTO 1
       ENDIF
       is(ql+sadmch_next)=p
      ENDIF
      next=next+1
      nu=next

2     is(p+sadmch_time)=0
      is(p+sadmch_tmsg)=0
      is(p+sadmch_tid )=0
      is(p+sadmch_tpid)=0
      is(p+sadmch_trc )=0
      is(p+sadmch_usag)=0
      is(p+sadmch_nodf)=sadmch_wait
      is(p+sadmch_stpa)=0
      is(p+sadmch_stpb)=0
      is(p+sadmch_res )=0
      is(p+sadmch_mxlo)=0
      is(p+sadmch_load)=0
      is(p+sadmch_cmd )=0
      is(p+sadmch_last)=0
      is(p+sadmch_numb)=nu
      cmch=p
      RETURN
      END
      SUBROUTINE sadmch_fnum(this_num)
*
* set cmch to SADMCH pointer corresponting to num
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER this_num
* local
      INTEGER p
      p=pmch
      cmch=0
1     IF (p.EQ.0) RETURN
      IF (is(p+sadmch_numb).EQ.this_num) THEN
       cmch=p
       RETURN
      ENDIF
      p=is(p+sadmch_next)
      GOTO 1
      END
      SUBROUTINE sadmch_fname(pp,name)
*
*     return first sadmch which matches name; start at pp
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER pp
      CHARACTER*(*) name
* local
      INTEGER iname(10)
      INTEGER p,i
      READ (name,'(10A4)') iname
      p=pp
      cmch=0
1     IF (p.EQ.0) RETURN
      DO i=1,10
       IF (is(p+sadmch_name+i-1).NE.iname(i)) GOTO 2
      ENDDO
      cmch=p
      RETURN
2     p=is(p+sadmch_next)
      GOTO 1
      END
      SUBROUTINE sadmch_ftid(this_tid)
*
* set cmch to SADMCH pointer corresponting to tid
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER this_tid
* local
      INTEGER p
      p=pmch
      cmch=0
1     IF (p.EQ.0) RETURN
      IF (is(p+sadmch_tid).EQ.this_tid) THEN
       cmch=p
       RETURN
      ENDIF
      p=is(p+sadmch_next)
      GOTO 1
      END
      SUBROUTINE sadmch_spmsg(p,t)
*
* set pmsg to t
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER p
      CHARACTER*(*) t
      CHARACTER*4 bl
      CHARACTER*40 x
      INTEGER i,l
      l=LEN(t)
      IF (l.EQ.1 .AND. t.EQ.' ') THEN
       bl='    '
       DO i=1,10
        READ (bl,'(A4)') is(p+sadmch_pmsg+i-1)
       ENDDO
       RETURN
      ENDIF
      DO i=1,40
       x(i:i)=' '
      ENDDO
      IF (l.GT.40) x=t(1:40)
      IF (l.LE.40) x(1:l)=t
      READ (x,'(10A4)') (is(p+sadmch_pmsg+i-1),i=1,10)
      RETURN
      END
      SUBROUTINE sadmch_sname(p,t)
*
* set name to t
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER p
      CHARACTER*(*) t
      CHARACTER*4 bl
      CHARACTER*40 x
      INTEGER i,l
      l=LEN(t)
      IF (l.EQ.1 .AND. t.EQ.' ') THEN
       bl='    '
       DO i=1,10
        READ (bl,'(A4)') is(p+sadmch_pmsg+i-1)
       ENDDO
       RETURN
      ENDIF
      DO i=1,40
       x(i:i)=' '
      ENDDO
      IF (l.GT.40) x=t(1:40)
      IF (l.LE.40) x(1:l)=t
      READ (x,'(10A4)') (is(p+sadmch_name+i-1),i=1,10)
      RETURN
      END
      SUBROUTINE sadmch_gname(p,t)
*
* extract name
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER p
      CHARACTER*(*) t
      CHARACTER*40 myname
      INTEGER i,l
      WRITE (myname,'(10A4)') (is(p+sadmch_name+i-1),i=1,10)
      l=LEN(t)
      DO i=1,l
       t(i:i)=' '
      ENDDO
      IF (l.LT.40) THEN
       t=myname(1:l)
      ELSE
       t(1:l)=myname
      ENDIF
      RETURN
      END
      SUBROUTINE sadmch_gpmsg(p,t)
*
* extract pmsg
*
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'param.h'
      INCLUDE 'sadmch.h'
      INTEGER p
      CHARACTER*(*) t
      CHARACTER*40 myname
      LOGICAL controlc
      INTEGER i,l
      WRITE (myname,'(10A4)') (is(p+sadmch_pmsg+i-1),i=1,10)
      DO i=1,40
       IF (controlc(myname(i:i))) myname(i:i)=' '
      ENDDO
      l=LEN(t)
      DO i=1,l
       t(i:i)=' '
      ENDDO
      IF (l.LT.40) THEN
       t=myname(1:l)
      ELSE
       t(1:l)=myname
      ENDIF
      RETURN
      END
