CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE shutdown
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INCLUDE 'sadmch.h'
      INTEGER i,k,xeq,p,tid,tpid,iwhat,info,l,mbuf
      CHARACTER*255 cmd
      CHARACTER*20 cpid
      CHARACTER*40 myname
C#    INTEGER w
C#    DATA w /MPI_COMM_WORLD/
C@    WRITE (*,*) '@shutdown@ enter'
*
* read last pending messages
*
      CALL fsys
*
* send all slaves the terminate signal
*
      iwhat=-1
      p=pmch
90    IF (p.EQ.0) GOTO 950
      IF (is(p+sadmch_nodf).EQ.sadmch_dead) GOTO 951
      IF (is(p+sadmch_nodf).EQ.sadmch_done) GOTO 951
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      CALL sadmch_gname(p,myname)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      CALL sadmch_fname(pvmmch,myname)
      k=is(p+sadmch_tid)
      l=0
      IF (cmch.GT.0) l=is(cmch+sadmch_usag)
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      IF(k.gt.0) THEN
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        WRITE (idbg,*) 'shutdow| sending finish signal to tid ',k

C:      CALL MPI_SSEND(iwhat,1,MPI_INTEGER,k,409,w,info)
C:      CALL mpierr('MPI_SSEND iwhat','parstuff',info)
C//SKIPC:2
C#      CALL MPI_SEND(iwhat,1,MPI_INTEGER,k,409,w,info)
C#      CALL mpierr('MPI_SEND iwhat','parstuff',info)

C//SKIPC#
        CALL pvmfinitsend(PVMDATADEFAULT,mbuf)
        CALL pvmfpack( INTEGER4, iwhat, 1, 1, info )
        CALL pvmfsend(k, 0, info )
C//END
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      END IF
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      IF (l.GT.0) THEN
       WRITE (jtape,'(''% work done on node '',a20,F10.2)')
     .  myname,100.*float(l)/float(nstept)
      ENDIF
951   p=is(p+sadmch_next)
      GOTO 90
950   CONTINUE

C//SKIPC#
      p=pmch
1     IF (p.EQ.0) GOTO 900
      IF (is(p+sadmch_tpid).GT.0) THEN
       tid=is(p+sadmch_tid)
       tpid=is(p+sadmch_tpid)
       CALL sadmch_gname(p,myname)
       WRITE (*,*) i,tid,tpid,' still running on ',myname
       WRITE (cpid,'(I20)') tpid
       CALL clean(cmd)
       cmd='dc_killtask '//myname//' '//cpid//' TMP_dc_killtask'
       info=xeq(cmd)
      ENDIF
      p=is(p+sadmch_next)
      GOTO 1
900   CONTINUE
C//END
      RETURN
      END
