CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE ssend(p,dip,pol,gra,stepfl,vmach)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'sadmch.h'
*
* send steps to be treated to node *p
*
      INTEGER stepfl(*)
      REAL*8 dip(*),pol(*),gra(*)
      INTEGER i,p
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INTEGER mbuf,info,j,nsec,nsed,nex,now,k,ize,ipe,iprc,cmd,nodf,q
      INTEGER*4 iwhat,i4,ia,tid
      REAL*8 vmach(*)
      CHARACTER*24 date
      CHARACTER*40 myname,name
      IF (p.EQ.0) CALL errex('stale pointer in ssend')

      cmd=is(p+sadmch_cmd)
      nodf=is(p+sadmch_nodf)
C@    WRITE (idbg,*) '  ssend| ',p,cmd,nodf

      IF (cmd.EQ.sadmch_term)
     *  CALL remnode(p,'term cmd',sadmch_term,stepfl)

      IF (nodf.NE.sadmch_rdy) RETURN
      IF (cmd .eq.sadmch_vbsy) RETURN

      i=is(p+sadmch_numb)
      tid=is(p+sadmch_tid)
      CALL sadmch_gname(p,myname)
C//NOTRACE

** check for pending steps
      DO j=1,nstept
       IF (stepfl(j).eq.0) then
        CALL secs(now)
        CALL howmany(ize,ipe,iprc,stepfl)
        IF (ize.LT.ipe) THEN

* check if a running node would finish the present job earlier than the
* currently ready node

* use the current node if no information about its performance is available
         nex=is(p+sadmch_last)
         IF (nex.EQ.0) GOTO 31
         nex=nex+now

         q=pmch
30       IF (q.EQ.0) GOTO 31

* OK, there is a ready node

         IF (is(q+sadmch_nodf).EQ.sadmch_rdy) THEN

* no performance information; bailout at this point, using it when ssend
* is called for that node

          nsed=is(q+sadmch_last)
          IF (nsed.EQ.0) GOTO 32

* check if this one will probably finish earlier than the current one ...

          nsed=is(q+sadmch_last)+now
          IF (nsed.LT.nex) GOTO 32
         ENDIF

* it migh be even advantageous to wait for a currently running node ...

         IF (is(q+sadmch_nodf).EQ.sadmch_rdy) THEN
          nsed=is(q+sadmch_last)*2+is(q+sadmch_time)
          IF (nsed.LT.nex) GOTO 32
         ENDIF
         q=is(q+sadmch_next)
         GOTO 30
*
* it seems to be advantageous not to use the present node.
*

32       CONTINUE
         CALL sadmch_gname(q,name)
         WRITE (idbg,*) '  ssend| ',name(1:8),
     *    ' expected to finish at ',nsed
         WRITE (idbg,*) '       | ',myname(1:8),
     *    ' expected to finish at ',nex
         WRITE (idbg,*) '       | so wait for ',name(1:8)
***      RETURN
31       CONTINUE
        ENDIF

        CALL flush(idbg)
        is(p+sadmch_time)=now
        ia=j
        is(p+sadmch_stpa)=ia
        stepfl(j)=-1
C        WRITE (myname(1:8),'(A8)') vmach(j)
C        WRITE (vmach(j),'(A8)') myname(1:8)
        READ(myname(1:8),'(A8)') vmach(j)
        CALL delp(vmach(j))
        GOTO 77
       ENDIF
      ENDDO
      RETURN

77    CALL fdate(date)
      WRITE (jtape,'(A,A,I10,1X,A,A,I4,A,I4)')
     . date,'-> ',tid,myname(1:8),' sending step',ia
      CALL flush(jtape)

      iwhat=1
      i4=i
C#    k=MPI_COMM_WORLD
C:    CALL MPI_SSEND(iwhat,1,MPI_INTEGER,tid,409,k,info)
C:    CALL mpierr('MPI_SSEND iwhat','ssend',info)
C:    CALL MPI_SSEND(i4,1,MPI_INTEGER,tid,410,k,info)
C:    CALL mpierr('MPI_SSEND i4','ssend',info)
C:    CALL MPI_SSEND(ia,1,MPI_INTEGER,tid,411,k,info)
C:    CALL mpierr('MPI_SSEND ia','ssend',info)
C//SKIPC:
C#    CALL MPI_SEND(iwhat,1,MPI_INTEGER,tid,409,k,info)
C#    CALL mpierr('MPI_SEND iwhat','ssend',info)
C#    CALL MPI_SEND(i4,1,MPI_INTEGER,tid,410,k,info)
C#    CALL mpierr('MPI_SEND i4','ssend',info)
C#    CALL MPI_SEND(ia,1,MPI_INTEGER,tid,411,k,info)
C#    CALL mpierr('MPI_SEND ia','ssend',info)
C//END
C//SKIPC#
      CALL PVMFINITSEND(PVMDATADEFAULT,mbuf)
      CALL PVMFPACK( INTEGER4, iwhat, 1, 1, info )
      CALL PVMFSEND( tid, 0, info )

      CALL PVMFINITSEND(PVMDATADEFAULT,mbuf)
      CALL PVMFPACK( INTEGER4, i4       , 1, 1, info )
      CALL PVMFPACK( INTEGER4, ia       , 1, 1, info )
      CALL PVMFSEND( tid, 0, info )
C//END
      is(p+sadmch_nodf)=sadmch_runn
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      CALL wrestart(vmach,dip,pol,gra,stepfl)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      RETURN
      END
      SUBROUTINE delp(t)
      IMPLICIT none
      CHARACTER*8 t
      INTEGER i,j
      DO i=1,8
       IF (t(i:i).EQ.'.') GOTO 1
      ENDDO
      RETURN
1     DO j=i,8
       t(j:j)=' '
      ENDDO
      RETURN
      END
