CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine sbox(aarg)
      character*(*) aarg
      write(*,110)
      write(*,*) aarg
      write(*,110)
110   format(70('-'))
      write(*,'(/)')
      return
      end

      subroutine header(aarg1,aarg2)
      character*(*) aarg1,aarg2

      write(*,130)
      write(*,110)
      write(*,110)
      write(*,121)aarg1
      write(*,121)aarg2
      write(*,110)
      write(*,110)
      write(*,130)
110   format(70('*'))
130   format(/)
120   format(/,20x,a,5x,i4,/)
121   format(/,20x,a,/)
 
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C connect two strings                         
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine sappend(s1,s2,s3)
      character*(*) s1
      character*(*) s2
      character*(*) s3
      integer i,k 
      CALL clean(s3)
      s3=' '
      k=0
      do i=1,len(s1)
         if(s1(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s1(i:i)
         endif
      enddo
      do i=1,len(s2)
         if(s2(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s2(i:i)
         endif
      enddo

      return
      end
      SUBROUTINE augnum(filename,name,number)
      IMPLICIT none
      CHARACTER*(*) filename,name
      INTEGER number
      INTEGER i,j,lf,ln
      CHARACTER*10 n8
      CALL clean(filename)
      lf=LEN(filename)
      ln=LEN(name)
      IF (ln+5.GT.lf)
     *  CALL errex('augnum: buffer length too small')
      CALL clean(filename)
      filename(1:ln)=name
      WRITE (n8,'(I010)') number
      DO j=1,10
      IF (n8(j:j).NE.' ') THEN
      ln=ln+1
      filename(ln:ln)=n8(j:j)
      ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE clean(c)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i
      DO i=1,LEN(c)
      c(i:i)=' '
      ENDDO
      RETURN
      END
      SUBROUTINE slen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=1,l
      IF (c(i:i).EQ.' ') THEN
       n=i-1
       RETURN
      ENDIF
      ENDDO
      n=l
      RETURN
      END
      SUBROUTINE llen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=l,1,-1
      IF (c(i:i).NE.' ') THEN
       n=i
       RETURN
      ENDIF
      ENDDO
      n=1
      RETURN
      END
      INTEGER FUNCTION INTGR(X,I,MX)
      CHARACTER*255 X
      CHARACTER*128 F
      DO 3 J=1,MX
      IF (X(J:J).NE.' ') GOTO 4
3     CONTINUE
      INTGR=0
      RETURN
4     CONTINUE
      DO 1 I=J,MX
      IF (X(I:I).GT.'9' .OR. X(I:I) .LT. '0') GOTO 2
1     CONTINUE
      I=21
2     I=I-J
      IF (I.EQ.0) THEN
      INTGR=0
      RETURN
      ENDIF
      WRITE (F,100) I
100   FORMAT('(I',I2,')')
      READ (X(J:20),F) K
      INTGR=K
      RETURN
      END
      SUBROUTINE SPLIT(X,ITEM,N)
      CHARACTER*(*) X
      CHARACTER*(*) ITEM(N)
      l=LEN(x)
      li=LEN(item(1))
      DO 90 I=1,N
      CALL CLEAN(ITEM(I))
90    CONTINUE
      I=0
      IT=0
1     I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).NE.' ') GOTO 10
      GOTO 1
10    IT=IT+1
      IF (IT.EQ.N) THEN
      ITEM(IT)(1:li-I)=X(I:L)
      GOTO 999
      ENDIF
      J=0
11    J=J+1
      ITEM(IT)(J:J)=X(I:I)
      I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).EQ.' ') THEN
      GOTO 1
      ENDIF
      GOTO 11
999   CONTINUE
      RETURN
      END

      INTEGER FUNCTION tmpxeq(cmd)
      IMPLICIT none
      INCLUDE 'param.h'
      CHARACTER*(*) cmd
      CHARACTER*255 cmdout
      INTEGER xeq
***   tmpxeq=xeq('. .profile; cd '//tempdir(1:lt)//'; '//cmd)
      CALL concat('cd ',tempdir(1:lt),cmdout)
      CALL appba(cmdout,'; ')
      CALL appba(cmdout,cmd)
      tmpxeq=xeq(cmdout)
      RETURN
      END

      INTEGER FUNCTION xeq(cmd)
      INCLUDE 'defs.h'
      CHARACTER*(*) cmd
      INTEGER i,fsystem,l
      CHARACTER*255 cbuf
      CALL clean(cbuf)
      CALL llen(cmd,l)
      cbuf(1:l)=cmd
      i=fsystem(l,cbuf)
      WRITE (iosl,*) 'xeq[',i,'] ',cmd
      CALL flush(iosl)
      xeq=i
C+    xeq=0
      RETURN
      END
      SUBROUTINE tosec(item,sec)
      IMPLICIT none
      CHARACTER*255 item(12)
      REAL*8 sec
      REAL*8 rr
      INTEGER i,intgr
      sec=0.D0
      IF (item(5).EQ.'seconds') THEN
       READ (item(4),'(D20.10)') sec
       RETURN
      ENDIF
      IF (item(5).EQ.'minutes') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(7),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'hours') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(9),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'days') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*86400.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(8),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(11),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      RETURN
      END
      SUBROUTINE snfdchead
      IMPLICIT none
      write(*,'(A)')
C                     +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')' +---------------------------------------------------------+'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |                        S N F D C                        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |    B. A. Hess, J. Neugebauer, M. Reiher, C. Kind        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |  Universitaet Erlangen, Egerlandstr. 3, 91058 Erlangen  |'
      write(*,'(A)')' |                        1999-2001                        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' +---------------------------------------------------------+'
C                     +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')
      RETURN
      END
