CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine wdal(tdr)
  
*     write DALTON input file molecule.mol
*     using the basis set editor "based" by B. A. Hess
*     Note: based must be available in $PATH
*
*     written by J. Neugebauer, Uni Erlangen, 2002

      include 'defs.h'
      integer info, system,ounit,ltd
      character*(*) tdr
      character*255 tmpc,fname
      parameter(ounit=1)
      logical ex
      
      call llen(tdr,ltd)
*      inquire(file='mos',exist=ex)
*      if(ex) then
*        call rmfile('mos.tmp',1)
*        info=system('mv mos mos.tmp')
*        if(info.ne.0) goto 900
*      end if
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.MOPUN'
      call rmfile(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.dalton'
      call rmfile(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.mol'
      call rmfile(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/basedscript.tmp'
      call rmfile(fname,1)
      open(unit=ounit,file=fname)
       call clean(tmpc)
       tmpc='cd '//tdr(1:ltd)
       write(ounit,'(a)') tmpc
       write(ounit,'(a)') 'based << !'
       call clean(tmpc)
       tmpc='re '//tdr(1:ltd)//'/control'
       write(ounit,'(a)') tmpc
       write(ounit,'(a)') 
       tmpc='wr '//tdr(1:ltd)//'/molecule.dalton'
       write(ounit,'(a)') tmpc
       write(ounit,'(a)') 'x'
       write(ounit,'(a)') '!'
       call clean(tmpc)
       tmpc='mv '//tdr(1:ltd)//'/molecule.dalton '
     *//tdr(1:ltd)//'/molecule.mol'
       write(ounit,'(a)') tmpc
      close(ounit)
      call exscript(fname)
*      if(ex) then
*        info=system('mv mos.tmp mos')
*        if(info.ne.0) goto 900
*      end if
      write(iosl,*) 'exit from wdal'
      return
900   write(iosl,*) '** wdal: error while creating molecule.mol'
      stop
      end

*************************************************************************
 
      subroutine exscript(rfile)
*
*     make script rfile executable and execute it.
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
      include 'defs.h'
      character*(*) rfile
      character*255 tmpchar
      integer info,system,lrfile
      logical ex
 
      call llen(rfile,lrfile)
      call clean(tmpchar)
      tmpchar='chmod u+x '//rfile(1:lrfile)
      info=system(tmpchar)
      if(info.ne.0) goto 900
      write(iosl,'(2a)') '** exscript: executing ',rfile(1:lrfile)
      write(*,'(72(''*''))')
      info=system(rfile(1:lrfile))
      if(info.ne.0) goto 900
      write(iosl,'(72(''*''))')
      return
900   write(iosl,'(2a)') '** exscript: could not execute ',
     *rfile(1:lrfile)
      stop
      end
 
  !************************************************************************
 
      subroutine rmfile(rfile,mode)
*
*     if rfile exists, then remove it. if mode = 1, move file to file.bak
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
      include 'defs.h'
      character*(*) rfile
      character*255 tmpchar,tmptxt
      integer mode,info,system,lrfile,ltxt
      logical ex
 
      call llen(rfile,lrfile)
      inquire(file=rfile(1:lrfile),exist=ex)
      call clean(tmpchar)
      if(ex) then
        if(mode.eq.1) then
          call clean(tmptxt)
          tmptxt=rfile(1:lrfile)//' to '//rfile(1:lrfile)//'.bak'
          call llen(tmptxt,ltxt)
          write(iosl,'(2a)') '** rmfile: moving file ',tmptxt(1:ltxt)
          tmpchar='mv '//rfile(1:lrfile)//' '//rfile(1:lrfile)//'.bak'
          info=system(tmpchar)
        else
         write(iosl,'(2a)') '** rmfile: removing file ',rfile(1:lrfile)
         tmpchar='rm '//rfile(1:lrfile)
         info=system(tmpchar)
        end if
        if(info.ne.0) then
         write(iosl,'(2a)') '** Error while (re)moving ',rfile(1:lrfile)
        end if
      end if
      end

 
  !************************************************************************
 

                            
