CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rslave(grad,co,ilab)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      INTEGER ibuf,info,nn,iat,idum,ixyz,irc,idir,l,mypid,
     * idmy,j,mbuf,diraus,ldal,iclean,icleanl
      CHARACTER*255 dalname
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      REAL*8 escf,gsum

      integer lprop,lpol,ldscf,lgrad,kstep,xprog
CMR170202
      integer xprogb
CMR170202
      integer*4 itst,jstepa
      character*255 b1
      character*5 nic
      character*80 sdum,dalmw
      CHARACTER*24 date
      CHARACTER*255 dscfname,gradname,propname,polname
      REAL*8 cpu,wall,gcpu,gwall
      INTEGER nit
      INTEGER xeq,tmpxeq,icmp,idalmw,ldalmw
      REAL*8 grad(nvar),dipol(3),co(3,natoms),polar(8,mxomeg)
      REAL*8 dipal(3),dipbe(3)
      INTEGER ilab(natoms)

      logical found,snffast
C#    INTEGER w,st(MPI_STATUS_SIZE)
C#    DATA w /MPI_COMM_WORLD/
 
      nic='nice '
      ipid=0
c receive step range     
C#    CALL MPI_RECV(itst,1,MPI_INTEGER,tid0,410,w,st,info)
C#    CALL mpierr('MPI_RECV itst','rslave',info)
C#    CALL MPI_RECV(jstepa,1,MPI_INTEGER,tid0,411,w,st,info)
C#    CALL mpierr('MPI_RECV jstepa','rslave',info)
C//SKIPC#
      CALL PVMFRECV(tid0,0,ibuf)
      CALL PVMFUNPACK(INTEGER4,itst  ,1,1,info)
      CALL PVMFUNPACK(INTEGER4,jstepa,1,1,info)
C//END

      WRITE (iosl,*) '>>> slave calc on tid ',mytid
      WRITE (iosl,*) 'TID0=',tid0,' STEP ',jstepa

c read control

CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      idalmw=0
      call clean(dalmw)
      CALL rcontrol(tempdir(1:lt)//'/control',natoms,mode,inputdip,
     *inputpol, cstep,jscfc,isuhf,iomeg,mxomeg,omeg,naus,iclean,
     *icleanl,dalmw,idalmw,snffast,idbg)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c extract coords
      call rcoord(tempdir(1:lt)//'/coord.ori',nn,co,ilab)

      if(nn.ne.natoms) then
         write(iosl,*) 'natoms different on coord and control'
C//SKIPC#1
         CALL pvmfexit(info)
         stop
      endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c loop over steps
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      kstep=1

      

c determine atom, xyz and dir for step i

CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      iat=jstepa/(3*naus)
      if(MOD(jstepa,(3*naus)).ne.0.or.iat.eq.0) iat=iat+1
      idum=(jstepa-(3*naus)*(iat-1))
      ixyz=idum/naus
      if(mod(idum,naus).ne.0) ixyz=ixyz+1
      diraus=mod(idum,naus)
      if(diraus.eq.0) diraus=naus
      idir=naus/2-diraus+1
      if(idir.le.0) idir=idir-1
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      write(iosl,*) 'step       =        ',jstepa
      write(iosl,*) 'atom       =        ',iat
      write(iosl,*) 'coordinate =        ',ixyz
      write(iosl,*) 'idir       =        ',idir

c remove old output files (gradient)
      irc=xeq('rm -rf '//tempdir(1:lt)//'/gradient')

* restore MO vector
         IF (isuhf.EQ.0) THEN
          CALL getmos('mos',jstepa,mypid)
         ELSE
          CALL getmos('alpha',jstepa,mypid)
          CALL getmos('beta',jstepa,mypid)
         ENDIF

* change coordinate

      co(ixyz,iat)=co(ixyz,iat)+idir*cstep
    
      call wcoord(tempdir(1:lt)//'/coord',natoms,co,ilab)
      if(mode.ge.20.and.mode.le.25) then
        call wdal(tempdir(1:lt))
      end if

* switch on archiving; make sure that the filename is followed by a blank

         IF (isuhf.EQ.0) THEN
          CALL archiving(tempdir,'mos ',arpath,jstepa,1)
         ELSE
          CALL archiving(tempdir,'alpha ',arpath,jstepa,1)
          CALL archiving(tempdir,'beta ',arpath,jstepa,2)
         ENDIF

* do the calculation

      WRITE (iosl,*) 'MODE=',mode
      if(snffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if

CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      IF (mode.eq.1.or.mode.eq.5.or.mode.eq.6) THEN
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
         CALL archiving(tempdir,'whatever ',arpath,0,0)
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog(nic(1:5)//turbodir(1:lb)//'grad',gradname(1:lgrad))
         CALL augnum(propname,'dip.out.',jstepa)
         CALL llen(propname,lprop)
         IF (inputdip.eq.1) THEN
          IF (isuhf.EQ.0) THEN
           info=xprog(nic(1:5)//turbodir(1:lb)//'moloch',
     *       propname(1:lprop))
           CALL getdip(dipol,tempdir(1:lt)//'/control')
          ELSE
*
* for UHF cases, calculate dipol moment as arithmetic mean of calculations
* with closed-shell occupations set to either alpha or beta occupations;
* to accomplish that, change control file accordingly, and then copy alpha
* or beta MO file to <mos>, changing the tags accordingly
*
           CALL fudge_control('$alpha shells',tempdir(1:lt))
           CALL fudge_mos(tempdir(1:lt),'alpha')
CMR170202           info=xprog(turbodir(1:lb)//'moloch',propname(1:lprop))
           info=xprogb(turbodir(1:lb)//'moloch',propname(1:lprop))
           call actest('moloch',found)
           if((info.eq.0).and.(.not.found)) then
             CALL getdip(dipal,tempdir(1:lt)//'/control')
           end if
cMR
           irc=xeq('cp '//tempdir(1:lt)//'/control '//tempdir(1:lt)//
     &'/control.bu')
           IF (irc.NE.0) THEN
              WRITE (iosl,*) 'rslave: difficulties copying control'
              WRITE (iosl,*) 'rslave: RC=',irc
              RETURN
           ENDIF
cMR
           CALL fudge_control('$beta shells',tempdir(1:lt))
           CALL fudge_mos(tempdir(1:lt),'beta')
CMR170202           info=xprog(turbodir(1:lb)//'moloch',propname(1:lprop))
           info=xprogb(turbodir(1:lb)//'moloch',propname(1:lprop))
           call actest('moloch',found)
           if((info.eq.0).and.(.not.found)) then
             CALL getdip(dipbe,tempdir(1:lt)//'/control')
             DO icmp=1,3
              dipol(icmp)=0.5D0*(dipal(icmp)+dipbe(icmp))
             ENDDO
           end if
          ENDIF
         ENDIF
         IF (inputpol.ge.1) THEN
          CALL augnum(polname,'pol.out.',jstepa)
          CALL llen(polname,lpol)
          CALL archiving(tempdir,'nconvx ',arpath,jstepa,1)
* get nconvx, in case that this is a restart
          CALL getarch('nconvx ',jstepa,mypid,irc)
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
          IF(mode.eq.5) THEN
           info=xprog(nic(1:5)//turbodir(1:lb)//'escf.intel',
     *        polname(1:lpol))
          ELSE IF(mode.eq.6) THEN
            info=xprog(nic(1:5)//turbodir(1:lb)//'escf.athlon',
     *        polname(1:lpol))
          ELSE IF(mode.eq.1) THEN
            info=xprog(nic(1:5)//turbodir(1:lb)//'escf',polname(1:lpol))
          END IF
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          CALL archiving(tempdir,'whatever ',arpath,0,0)
         ENDIF
         CALL mnotify(5,mypid,1,'tm done',7)
      ELSE IF (mode.eq.2.or.mode.eq.7.or.mode.eq.8) THEN
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'ridft',dscfname(1:ldscf))
         CALL archiving(tempdir,'whatever ',arpath,0,0)
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog(nic(1:5)//turbodir(1:lb)//'rdgrad',gradname(1:lgrad))
         CALL augnum(propname,'dip.out.',jstepa)
         CALL llen(propname,lprop)
         IF (inputdip.eq.1) THEN
          IF (isuhf.EQ.0) THEN
           info=xprog(turbodir(1:lb)//'moloch',propname(1:lprop))
           CALL getdip(dipol,tempdir(1:lt)//'/control')
          ELSE
*
* for UHF cases, calculate dipol moment as arithmetic mean of calculations
* with closed-shell occupations set to either alpha or beta occupations;
* to accomplish that, change control file accordingly, and then copy alpha
* or beta MO file to <mos>, changing the tags accordingly
*
           CALL fudge_control('$alpha shells',tempdir(1:lt))
           CALL fudge_mos(tempdir(1:lt),'alpha')
CMR170202           info=xprog(turbodir(1:lb)//'moloch',propname(1:lprop))
           info=xprogb(turbodir(1:lb)//'moloch',propname(1:lprop))
           call actest('moloch',found)
           if((info.eq.0).and.(.not.found)) then
             CALL getdip(dipal,tempdir(1:lt)//'/control')
           end if
cMR
           irc=xeq('cp '//tempdir(1:lt)//'/control '//tempdir(1:lt)//
     &'/control.bu')
           IF (irc.NE.0) THEN
              WRITE (iosl,*) 'rslave: difficulties copying control'
              WRITE (iosl,*) 'rslave: RC=',irc
              RETURN
           ENDIF
cMR
           CALL fudge_control('$beta shells',tempdir(1:lt))
           CALL fudge_mos(tempdir(1:lt),'beta')
CMR170202           info=xprog(turbodir(1:lb)//'moloch',propname(1:lprop))
           info=xprogb(turbodir(1:lb)//'moloch',propname(1:lprop))
           call actest('moloch',found)
           if((info.eq.0).and.(.not.found)) then
             CALL getdip(dipbe,tempdir(1:lt)//'/control')
             DO icmp=1,3
              dipol(icmp)=0.5D0*(dipal(icmp)+dipbe(icmp))
             ENDDO
           end if
          ENDIF
         ENDIF

CJN ridft available for raman calculations using escf.intel
CJN or escf.athlon

         IF (inputpol.ge.1) THEN
          CALL augnum(polname,'pol.out.',jstepa)
          CALL llen(polname,lpol)
          CALL archiving(tempdir,'nconvx ',arpath,jstepa,1)
* get nconvx, in case that this is a restart
          CALL getarch('nconvx ',jstepa,mypid,irc)
          IF(mode.eq.7) THEN
           info=xprog(nic(1:5)//turbodir(1:lb)//'escf.intel',
     *        polname(1:lpol))
          ELSE IF(mode.eq.8) THEN
            info=xprog(nic(1:5)//turbodir(1:lb)//'escf.athlon',
     *        polname(1:lpol))
          ELSE
            write(idbg,*) '** ERROR: NO RAMAN IN THIS MODE'
            stop
          END IF
          CALL archiving(tempdir,'whatever ',arpath,0,0)
         ENDIF
         CALL mnotify(5,mypid,1,'tm done',7)
      ELSE IF(mode.ge.20.and.mode.le.25) THEN
       CALL augnum(dalname,'dal.out.',jstepa)
       CALL llen(dalname,ldal)
       CALL llen(dalmw,ldalmw)

CJN set maximum scratch memory if dalmw is specified in "control"

       if(idalmw.le.800000) then
         if(idalmw.ne.0) then
          write(idbg,*) 
     & 'rslave: using dalton with default scratch memory size'
          write(idbg,*) 'idalmw = ',idalmw
         end if
         info=xprog(nic(1:5)//turbodir(1:lb)//'dalton molecule molecule',
     &          dalname(1:ldal))
       else 
         info=xprog(nic(1:5)//turbodir(1:lb)//'dalton -m '
     & //dalmw(1:ldalmw)//' molecule molecule',dalname(1:ldal))
       end if
       IF (inputdip.eq.1) THEN
        IF(mode.ge.21.and.mode.le.24) THEN
          CALL gdaldip(dipol,tempdir(1:lt)//'/molecule.out')
        ELSE IF(mode.eq.20.or.mode.eq.25) THEN
          CALL gdaldipscf(dipol,tempdir(1:lt)//'/molecule.out')
        END IF
       END IF
       GOTO 70
      ENDIF   
      if(mode.eq.3) then        
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog(nic(1:5)//turbodir(1:lb)//'rimp2',gradname(1:lgrad))
         CALL getdipmp2(dipol,tempdir(1:lt)//'/'//gradname(1:lgrad))
      endif   
      if(mode.eq.4) then        
         CALL augnum(dscfname,'dscf.out.',jstepa)
         CALL llen(dscfname,ldscf)
         info=xprog(nic(1:5)//turbodir(1:lb)//'dscf',dscfname(1:ldscf))
         CALL augnum(gradname,'grad.out.',jstepa)
         CALL llen(gradname,lgrad)
         info=xprog(nic(1:5)//turbodir(1:lb)//'mpgrad',gradname(1:lgrad))
         CALL getdipmp2(dipol,tempdir(1:lt)//'/'//gradname(1:lgrad))
      endif   
      CALL rxxxx(dscfname,nit,cpu,wall)
      CALL rxxxx(gradname,idmy,gcpu,gwall)
      WRITE (iosl,*) 'iterations: ',nit
      WRITE (iosl,*) 'cpu       : ',cpu,gcpu
      WRITE (iosl,*) 'wall      : ',wall,gwall

      CALL flush(iosl)
      CALL mnotify(5,mypid,6,'times read',10)

      CALL findstr(tempdir(1:lt)//'/control','$actual',found)
      IF (found) THEN
       CALL mnotify(5,mypid,7,'$actual found',13)
       WRITE (iosl,*)
     * '$actual found in control file ... shutting down node'
       CALL flush(iosl)
       CALL slshutdown(1,tid0,mytid)
      ENDIF

70    CONTINUE

c back to original value

      co(ixyz,iat)=co(ixyz,iat)-idir*cstep

** read gradient (and polarizabilities) in case of DALTON calculations

      IF(mode.ge.21.and.mode.le.24) THEN
        CALL gdalgrad(natoms,escf,grad,tempdir(1:lt)//'/molecule.out')
        IF (inputpol.GT.0)
     *   CALL gdalpol(polar,tempdir(1:lt)//'/molecule.out')
      ELSE IF(mode.eq.20.or.mode.eq.25) THEN
        CALL gdalgradscf(natoms,escf,grad,
     *    tempdir(1:lt)//'/molecule.out')
        IF (inputpol.GT.0)
     *   CALL gdalpolscf(polar,tempdir(1:lt)//'/molecule.out')
      ELSE

** read gradient

        CALL getgrad(natoms,escf,grad,tempdir(1:lt)//'/gradient')

** save gradient file

        CALL augnum(gradname,tempdir(1:lt)//'/gradient.',jstepa)
        CALL llen(gradname,lgrad)
        irc=xeq('mv '//tempdir(1:lt)//'/gradient '//gradname(1:lgrad))

** read dipole moment

**      IF (isuhf.EQ.0) THEN
**       CALL getdip(dipol,tempdir(1:lt)//'/control')
**      ELSE
**       dipol(1)=0.D0
**       dipol(2)=0.D0
**       dipol(3)=0.D0
**      ENDIF

** read polarizability

        IF (inputpol.GT.0)
     *   CALL getpol(polar,tempdir(1:lt)//'/'//polname(1:lpol))
      END IF

      CALL mnotify(5,mypid,5,'results read',12)

      gsum=0.0d0
      do j=1,nvar    
         gsum=gsum+grad(j)**2
      enddo
      WRITE (iosl,*) 'grad norm',gsum
      CALL flush(iosl)

      call clean(sdum)
      IF(mode.lt.20) THEN
        call findstr(tempdir(1:lt)//'/control','$actual',found)
c something was wrong in TURBOMOLE calculation
999     if (found) then
         CALL mnotify(5,mypid,8,'results weird',13)
         escf=999.D0
        endif
      END IF

      IF(iclean.eq.1) THEN
        info=xeq('rm -r '//tempdir(1:lt))
      END IF
c send final results

C:      CALL MPI_SSEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C:      CALL mpierr('MPI_SSEND nit','rslave',info)
C:      CALL MPI_SSEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C:      CALL mpierr('MPI_SSEND cpu','rslave',info)
C:      CALL MPI_SSEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C:      CALL mpierr('MPI_SSEND wall','rslave',info)
C:      CALL MPI_SSEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C:      CALL mpierr('MPI_SSEND gcpu','rslave',info)
C:      CALL MPI_SSEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C:      CALL mpierr('MPI_SSEND gwall','rslave',info)
C:      CALL MPI_SSEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C:      CALL mpierr('MPI_SSEND out1','rslave',info)
C:      CALL MPI_SSEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C:      CALL mpierr('MPI_SSEND dipol','rslave',info)
C:      CALL MPI_SSEND(grad,nvar,MPI_DOUBLE_PRECISION,
C:   *   tid0,807,w,info)
C:      CALL mpierr('MPI_SSEND escf','rslave',info)
C:      IF (inputpol.GT.0) THEN
C:       CALL MPI_SSEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C:   *    tid0,808,w,info)
C:       CALL mpierr('MPI_SSEND polar','rslave',info)
C//SKIPC:
C#      CALL MPI_SEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C#      CALL mpierr('MPI_SEND nit','rslave',info)
C#      CALL MPI_SEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C#      CALL mpierr('MPI_SEND cpu','rslave',info)
C#      CALL MPI_SEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C#      CALL mpierr('MPI_SEND wall','rslave',info)
C#      CALL MPI_SEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C#      CALL mpierr('MPI_SEND gcpu','rslave',info)
C#      CALL MPI_SEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C#      CALL mpierr('MPI_SEND gwall','rslave',info)
C#      CALL MPI_SEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C#      CALL mpierr('MPI_SEND escf','rslave',info)
C#      CALL MPI_SEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C#      CALL mpierr('MPI_SEND dipol','rslave',info)
C#      CALL MPI_SEND(grad,nvar,MPI_DOUBLE_PRECISION,
C#   *   tid0,807,w,info)
C#      CALL mpierr('MPI_SEND grad','rslave',info)
C#      IF (inputpol.GT.0) THEN
C#       CALL MPI_SEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C#   *    tid0,808,w,info)
C#       CALL mpierr('MPI_SEND polar','rslave',info)
C//END
C#      ENDIF
C//SKIPC#
      CALL PVMFINITSEND(PVMDATADEFAULT,MBUF)
      CALL PVMFPACK(INTEGER4,nit,kstep,1,info)
      CALL PVMFPACK(REAL8,cpu,kstep,1,info)
      CALL PVMFPACK(REAL8,wall,kstep,1,info)
      CALL PVMFPACK(REAL8,gcpu,kstep,1,info)
      CALL PVMFPACK(REAL8,gwall,kstep,1,info)
      CALL PVMFPACK(REAL8,escf,1,1, INFO )
      CALL PVMFPACK(REAL8,dipol,3,1,INFO )
      CALL PVMFPACK(REAL8,grad,nvar,1,INFO )
      IF (inputpol.GT.0) 
     *CALL PVMFPACK(REAL8,polar,8*ipol,1,INFO )
      CALL PVMFSEND( TID0, 0, INFO )
C//END
      CALL mnotify(5,mypid,9,'results sent',12)
      RETURN
      END 
      INTEGER FUNCTION xprog(p,f)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      CHARACTER*(*) p,f
      CHARACTER*255 cmdout
      INTEGER info,tmpxeq
      CHARACTER*24 date
      CALL fdate(date)
      CALL concat(p,' >',cmdout)
      CALL appba(cmdout,f)
C@    WRITE (iosl,*) date,cmdout
      info=tmpxeq(cmdout)
C@    WRITE (iosl,*) date,' RC=',info
      IF (info.NE.0) THEN
       WRITE (iosl,*) p,' failed; process shut down. mytid=',mytid
       CALL slshutdown(99,tid0,mytid)
      ENDIF
      xprog=info
      RETURN
      END
      SUBROUTINE slshutdown(ityp,loctid0,loctid)
      IMPLICIT none
      INTEGER ityp,loctid0,loctid
      INCLUDE 'comm.h'
      INCLUDE 'param.h'
      INTEGER*4 tid4,ityp4
      INTEGER mbuf,info
C#    INTEGER w
C#    DATA w /MPI_COMM_WORLD/

      CALL termpid(0)
C:    CALL MPI_SSEND(mytid,1,MPI_INTEGER,tid0,fsys_mpitag,w,info)
C:    CALL mpierr('MPI_SSEND mytid','slshutdown',info)
C:    CALL MPI_SSEND(fsys_taskstop,1,MPI_INTEGER,tid0,501,w,info)
C:    CALL mpierr('MPI_SSEND mnotify','slshutdown',info)
C:    CALL MPI_SSEND(ityp,1,MPI_INTEGER,tid0,601,w,info)
C:    CALL mpierr('MPI_SSEND ityp','slshutdown',info)
C//SKIPC:
C#    CALL MPI_SEND(mytid,1,MPI_INTEGER,tid0,fsys_mpitag,w,info)
C#    CALL mpierr('MPI_SEND mytid','slshutdown',info)
C#    CALL MPI_SEND(fsys_taskstop,1,MPI_INTEGER,tid0,501,w,info)
C#    CALL mpierr('MPI_SEND mnotify','slshutdown',info)
C#    CALL MPI_SEND(ityp,1,MPI_INTEGER,tid0,601,w,info)
C#    CALL mpierr('MPI_SEND ityp','slshutdown',info)
C//END
C//SKIPC#
      IF (loctid0.NE.PVMNOPARENT .AND. loctid.GE.0) THEN
** notify parent that this slave stops
       CALL PVMFINITSEND(PVMDATADEFAULT,mbuf)
       tid4=loctid
       CALL PVMFPACK(INTEGER4,tid4,1,1,info)
       ityp4=ityp
       CALL PVMFPACK(INTEGER4,ityp4,1,1,info)
       CALL PVMFSEND(loctid0,BAHTASKSTOP,info)
       IF (info.NE.0) CALL PVMFPERROR('[slshutdown] send stop msg',info)
      ENDIF
C//END
      CALL termcomm('rslave')
** termcomm will not return
      STOP 'miracle in rslave'
      END

CMR170202
      INTEGER FUNCTION xprogb(p,f)
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      CHARACTER*(*) p,f
      CHARACTER*255 cmdout
      INTEGER info,tmpxeq
      CHARACTER*24 date
      CALL fdate(date)
      CALL concat(p,' >',cmdout)
      CALL appba(cmdout,f)
C@    WRITE (iosl,*) date,cmdout
      info=tmpxeq(cmdout)
C@    WRITE (iosl,*) date,' RC=',info
      IF (info.NE.0) THEN
        WRITE (iosl,*) 'ERROR: ',p,' failed '
      ENDIF
      xprogb=info
      RETURN
      END
CMR170202
      
      subroutine actest(progn,found)
      include 'defs.h'
      include 'param.h'
      character*(*) progn
      character*7  actual
      integer info, tmpxeq,lprog
      logical found
      parameter(actual='$actual')
 
      found=.false.
      call llen(progn,lprog)
      call findstr(tempdir(1:lt)//'/control',actual(1:7),found)
      if(found) then
        write(iosl,*) '** actest: found $actual in control'
        write(iosl,*) '**         program in trouble: ',progn(1:lprog)
        if(lb.eq.0) then
          info=tmpxeq('actual -r')
        else
          info=tmpxeq(turbodir(1:lb)//'../scripts/actual -r')
        end if
        if(info.ne.0) then
          write(iosl,*) '** actest: could not execute actual -r'
          call slshutdown(99,tid0,mytid)
        end if
      end if
      end
